package com.baojia.mebike.data.response.shopping

import android.os.Parcel
import android.os.Parcelable

data class OrderConfirmBean(var title: String?, var bikeImgUrl: String?, var color: String?, var totalMoney: Double, var listData: ArrayList<OrderConfirmItemBean>) : Parcelable {
    constructor(source: Parcel) : this(
            source.readString(),
            source.readString(),
            source.readString(),
            source.readDouble(),
            ArrayList<OrderConfirmItemBean>().apply { source.readList(this as List<*>, OrderConfirmItemBean::class.java.classLoader) }
    )

    override fun describeContents() = 0

    override fun writeToParcel(dest: Parcel, flags: Int) = with(dest) {
        writeString(title)
        writeString(bikeImgUrl)
        writeString(color)
        writeDouble(totalMoney)
        writeList(listData as List<*>?)
    }

    companion object {
        @JvmField
        val CREATOR: Parcelable.Creator<OrderConfirmBean> = object : Parcelable.Creator<OrderConfirmBean> {
            override fun createFromParcel(source: Parcel): OrderConfirmBean = OrderConfirmBean(source)
            override fun newArray(size: Int): Array<OrderConfirmBean?> = arrayOfNulls(size)
        }
    }
}

data class OrderConfirmItemBean(var itemTitle: String?, var itemDesc: String?, var itemMoney: String?, var itemTime: String?) : Parcelable {
    constructor(source: Parcel) : this(
            source.readString(),
            source.readString(),
            source.readString(),
            source.readString()
    )

    override fun describeContents() = 0

    override fun writeToParcel(dest: Parcel, flags: Int) = with(dest) {
        writeString(itemTitle)
        writeString(itemDesc)
        writeString(itemMoney)
        writeString(itemTime)
    }

    companion object {
        @JvmField
        val CREATOR: Parcelable.Creator<OrderConfirmItemBean> = object : Parcelable.Creator<OrderConfirmItemBean> {
            override fun createFromParcel(source: Parcel): OrderConfirmItemBean = OrderConfirmItemBean(source)
            override fun newArray(size: Int): Array<OrderConfirmItemBean?> = arrayOfNulls(size)
        }
    }
}
