package com.baojia.mebike.feature.exclusive.iWillExchange

import android.app.Activity
import android.content.Intent
import android.os.Bundle
import android.text.TextUtils
import android.view.View
import androidx.recyclerview.widget.LinearLayoutManager
import androidx.recyclerview.widget.RecyclerView
import com.baojia.mebike.R
import com.baojia.mebike.alipay.AliPayManager
import com.baojia.mebike.base.BaseActivity
import com.baojia.mebike.callback.IDialogCallback
import com.baojia.mebike.callback.PayListener
import com.baojia.mebike.data.response.exclusive.IWillExchangeResponse
import com.baojia.mebike.data.response.order.PayByOtherResponse
import com.baojia.mebike.dialog.LeftRightButtonTipsDialog
import com.baojia.mebike.feature.exclusive.detail.ExchangeIntroduceAdapter
import com.baojia.mebike.feature.exclusive.nearBike.NearBikeActivity
import com.baojia.mebike.feature.exclusive.personalChangeBattery.PersonalChangeBatteryActivity
import com.baojia.mebike.feature.exclusive.powerStation.PowerStationActivity
import com.baojia.mebike.feature.exclusive.shopping.renewalfee.RenewalFeeAct
import com.baojia.mebike.feature.exclusive.shopping.sendprogress.SendProgressActivity
import com.baojia.mebike.imageloader.ImageLoader
import com.baojia.mebike.util.DensityUtil
import com.baojia.mebike.util.Toast
import com.baojia.mebike.util.ToolBox
import com.baojia.mebike.util.WechatPayUtils
import com.baojia.mebike.util.recyclerview.RecycleViewDivider
import kotlinx.android.synthetic.main.activity_iwill_exchange.*
import kotlinx.android.synthetic.main.include_renewal_combo.*
import kotlinx.android.synthetic.main.layout_tips_common.*
import java.util.*

class IwillExchangeActivity : BaseActivity(), IwillExchangeContract.View, PayListener {


    override fun layoutId(): Int = R.layout.activity_iwill_exchange

    override fun setTitle(): String = "我要换电"

    private val mData: ArrayList<IWillExchangeResponse.DataBean.ListBean> = arrayListOf()
    private val adapter = IwillExchangeAdapter(this, mData, R.layout.item_iwill_exchange)
    // 换电须知
    private val exchangeIntroduceData = arrayListOf<IWillExchangeResponse.DataBean.KnowListBean>()
    private var exchangeIntroduceAdapter: ExchangeIntroduceAdapter? = null

    private var mPresenter: IwillExchangeContract.Presenter? = null
    private var payMethod: Int = 0
    //0 免费上门换电  1 自行换电 2紧急上门换电  3 跟换车辆
    private var type = 0
    private var exchangeDialog: ExchangeDialog? = null
    // 车辆id
    private var bikeId: Int = 0
    private var subType: Int = 2
    private var paymentType: Int = 0
    // 套餐订单号
    private var changeOrderNo: String? = null
    private var changeBatteryId: Long = 0
    private var productId: Long = 0
    private var virGroupId: Long = 0
    private var pmallOrderId: Int = 0
    private var productOrderNo: String? = null

    override fun bindView(savedInstanceState: Bundle?) {

        intent?.let {
            bikeId = it.getIntExtra("bikeId", 0)
            changeOrderNo = it.getStringExtra("changeOrderNo")
            productId = it.getLongExtra("productId", productId)
            virGroupId = it.getLongExtra("virGroupId", virGroupId)
            pmallOrderId = it.getIntExtra("pmallOrderId", pmallOrderId)
            productOrderNo = it.getStringExtra("productOrderNo")
        }

        mPresenter = IwillExchangePresenter(this, this)

        iWillExchangeRcyclerView.layoutManager = LinearLayoutManager(this)
        iWillExchangeRcyclerView.adapter = adapter
        iWillExchangeRcyclerView.addItemDecoration(RecycleViewDivider(this, RecyclerView.VERTICAL, DensityUtil.dip2px(this, 15f), R.color.white_color))

        adapter.setOnItemClickListner { _, position ->
            run {

                paymentType = 0
                when (mData[position].id) {
                    1 -> {
                        showExchangeDialog(position, 1)
                    }
                    2, 4 -> {
                        mData[position].isSelect = true
                        adapter.notifyItemChanged(position)
                        showExchangeDialog(position)
                    }
                    3 -> {
                        // 紧急换电
                        if (!ToolBox.isCompanyExclusive()) {
                            if (mPresenter?.dataBean()?.bought == 0) {
                                // 弹窗
                                val dialog = LeftRightButtonTipsDialog.show(supportFragmentManager, null, "您未购买换电无忧套餐，购买换电无忧套餐即可享受紧急上门换电", 2, R.mipmap.none_change_battery, "放弃", "立即购买")
                                dialog.setDialogCallback(object : IDialogCallback() {
                                    override fun onConfirm() {
                                        super.onConfirm()
                                        RenewalFeeAct.start(this@IwillExchangeActivity, 2, bikeId, pmallOrderId, virGroupId.toInt())
                                    }
                                })
                                return@setOnItemClickListner
                            }
                        }
                        when (mPresenter?.dataBean()?.isExistChangeBattery) {
                            1 -> {
                                // 有普通换电
                                // 升级提示
                                val dialog = LeftRightButtonTipsDialog.show(supportFragmentManager, null, "您发起一个免费上门换电\n是否要升级为紧急上门换电", 2, R.mipmap.change_battery_update_icon)
                                dialog.setDialogCallback(object : IDialogCallback() {
                                    override fun onConfirm() {
                                        super.onConfirm()
                                        // 升级为紧急换电
                                        mData[position].isSelect = true
                                        adapter.notifyItemChanged(position)
                                        paymentType = 18
                                        changeBatteryId = mPresenter?.dataBean()?.changeBatteryId!!
                                        // 正常
                                        showExchangeDialog(position)
                                    }

                                    override fun onCancel() {
                                        super.onCancel()
                                        if (mPresenter?.dataBean()?.isCancel == 0) {
                                            SendProgressActivity.start(this@IwillExchangeActivity, 1, changeOrderNo, mPresenter?.dataBean()?.changeBatteryId, if (mPresenter?.dataBean()?.isExistChangeBattery == 1) 1 else 2)
                                            return
                                        }
                                        Toast.show(this@IwillExchangeActivity, mData[position].toastDesc)
                                    }
                                })
                                return@setOnItemClickListner
                            }
                            2 -> {
                                // 有紧急换电、运维换电
                                Toast.show(this@IwillExchangeActivity, mData[position].toastDesc)
                                SendProgressActivity.start(this@IwillExchangeActivity, 1, changeOrderNo, mPresenter?.dataBean()?.changeBatteryId, if (mPresenter?.dataBean()?.isExistChangeBattery == 1) 1 else 2)
                                return@setOnItemClickListner
                            }
                            3 -> {
                                Toast.show(this@IwillExchangeActivity, mData[position].toastDesc)
                            }
                            else -> {
                                mData[position].isSelect = true
                                adapter.notifyItemChanged(position)
                                showExchangeDialog(position)
                            }
                        }
                    }
                    5 -> {
                        PersonalChangeBatteryActivity.start(this@IwillExchangeActivity, bikeId, mPresenter?.dataBean()?.isElectricLock!!, mPresenter?.dataBean()?.lockDesc)
                    }
                    else -> {
                    }
                }

            }
        }



        exchangeIntroduceAdapter = ExchangeIntroduceAdapter(this, exchangeIntroduceData, R.layout.item_text_draw)
        commonTipsRecyclerView.layoutManager = LinearLayoutManager(this)
        commonTipsRecyclerView.adapter = exchangeIntroduceAdapter
        commonTipsRecyclerView.addItemDecoration(RecycleViewDivider(this, RecyclerView.VERTICAL, DensityUtil.dip2px(this, 10f), R.color.white_color))

        setViewClickDuration(buyImageView, 1)
        setViewClickDuration(renewalButton, 1)
    }

    fun showExchangeDialog(position: Int, buttonCount: Int = 2) {
        exchangeDialog = ExchangeDialog.showDialog(supportFragmentManager, mData[position].id, mData[position].knowList,
                mData[position].knowListTitle, mData[position].amount.toString(), mData[position].leaveTimesDesc, buttonCount)

        exchangeDialog?.setiDialogCallback(object : ExchangeDialog.IDialogCallback {
            override fun onCancel() {
                mData[position].isSelect = false
                adapter.notifyItemChanged(position)
            }

            override fun onConfirm(payMethod: Int) {
                when (mData[position].id) {
                    1 -> {
                        mData[position].isSelect = false
                        adapter.notifyItemChanged(position)
//                        subType = 2
//                        // 普通上门换电
//                        mPresenter?.exchangePower()
                    }
                    2 -> {
                        // 自行换电
                        mData[position].isSelect = false
                        adapter.notifyItemChanged(position)
                        PowerStationActivity.start(this@IwillExchangeActivity, bikeId)
                    }
                    3 -> {
                        // 紧急换电
                        mData[position].isSelect = false
                        adapter.notifyItemChanged(position)

                        if (mData[position].isChangeFree == 1) {
                            //有免费次数
                            subType = 1
                            mPresenter?.exchangePower()
                        } else {
                            // 没有免费次数
                            this@IwillExchangeActivity.payMethod = payMethod
                            mPresenter?.payRequest()
                        }
                    }
                    4 -> {
                        mData[position].isSelect = false
                        adapter.notifyItemChanged(position)
                        if (ToolBox.isCompanyExclusive()) {
                            // 更换车辆
                            val intent = Intent(this@IwillExchangeActivity, NearBikeActivity::class.java)
                            intent.putExtra("bikeId", bikeId)
                            startActivity(intent)
                        } else {
                            // 个人专享更换车辆
                            val bundle = Bundle()
                            bundle.putString("changeOrderNo", changeOrderNo)
                            bundle.putString("orderNo", productOrderNo)
                            com.baojia.mebike.feature.exclusive.shopping.nearBike.NearBikeActivity.start(this@IwillExchangeActivity,
                                    productOrderNo, bundle, 5, productId)
                        }
                    }
                    5 -> {
                        // 自行充电
                        // 跳转电池仓
                        PersonalChangeBatteryActivity.start(this@IwillExchangeActivity, bikeId, mPresenter?.dataBean()?.isElectricLock!!, mPresenter?.dataBean()?.lockDesc)
                    }
                }
            }
        })
    }

    override fun setViewClick(view: View?) {
        super.setViewClick(view)
        when (view) {
            renewalButton, buyImageView -> {
                // 购买、续期 跳转同一页面
                RenewalFeeAct.start(this, 2, bikeId, pmallOrderId, virGroupId.toInt())
            }
        }
    }

    override fun onResume() {
        super.onResume()
        mPresenter?.getData()
        mPresenter?.checkOrderPayStatus()
    }

    override fun channelMethod(): Int = payMethod

    override fun wechatPay(dataBean: PayByOtherResponse.DataBean?) {
        WechatPayUtils.wechatPay(this, dataBean?.appid, dataBean?.partnerid, dataBean?.prepayid,
                dataBean?.wxpackage, dataBean?.noncestr, dataBean?.timestamp,
                dataBean?.sign)
    }

    override fun aliPay(dataBean: PayByOtherResponse.DataBean?) {
        AliPayManager(this)
                .alipayV2(this, dataBean?.orderInfo)
    }

    override fun setData(data: ArrayList<IWillExchangeResponse.DataBean.ListBean>?) {

        data?.let {
            mData.clear()
            mData.addAll(it)
            adapter.notifyDataSetChanged()
        }

    }

    override fun setIntroduceData(title: String?, data: ArrayList<IWillExchangeResponse.DataBean.KnowListBean>?) {
        exchangeIntroduceData.clear()
        data?.let {
            exchangeIntroduceData.addAll(it)
            exchangeIntroduceAdapter?.notifyDataSetChanged()
        }
        if (!TextUtils.isEmpty(title)) {
            commonTipsTitle.text = title
        }
    }


    override fun setPresenter(presenter: IwillExchangeContract.Presenter?) {
        this.setIPresenter(presenter)
    }

    override fun onSuccess() {

    }

    override fun onFailed(msg: String?) {
        msg?.run {
            Toast.show(this@IwillExchangeActivity, msg)
        }
    }

    override fun isVisibleTitleBar(): Boolean {
        return true
    }

    override fun getType(): Int = type

    override fun bikeId(): Int = bikeId

    override fun subType(): Int = subType

    override fun orderNo(): String? = changeOrderNo

    override fun paymentType(): Int = paymentType

    override fun changeBatteryId(): Long = changeBatteryId

    override fun setOrderNo(orderNo: String?) {
        if (TextUtils.isEmpty(orderNo)) {
            return
        }
        this.changeOrderNo = orderNo
    }

    override fun showBuyLayout(url: String?) {
        buyImageView.visibility = View.VISIBLE
        renewalLayout.visibility = View.GONE
        ImageLoader.loadRoundImageFitxy(this, buyImageView, url, DensityUtil.dip2px(this, 5.0f).toFloat())
    }

    override fun showRenewalLayout(buttonValue: String, placeholder: String, title: String) {
        buyImageView.visibility = View.INVISIBLE
        renewalLayout.visibility = View.VISIBLE
        renewalButton.text = buttonValue
        comboTimeTextView.text = placeholder
        comboTitle.text = title
    }

    companion object {
        @JvmStatic
        fun start(activity: Activity, bikeId: Int, changeOrderNo: String? = "", productId: Long, productOrderNo: String? = "", virGroupId: Long? = 0, pmallOrderId: Int?) {
            val intent = Intent(activity, IwillExchangeActivity::class.java)
            intent.putExtra("bikeId", bikeId)
            if (!TextUtils.isEmpty(changeOrderNo)) {
                intent.putExtra("changeOrderNo", changeOrderNo)
            }
            intent.putExtra("pmallOrderId", pmallOrderId)
            intent.putExtra("productId", productId)
            intent.putExtra("virGroupId", virGroupId)
            intent.putExtra("productOrderNo", productOrderNo)
            activity.startActivity(intent)
        }
    }
}