package com.baojia.mebike.feature.exclusive.iWillExchange

import android.app.Activity
import android.graphics.Color
import android.text.SpannableString
import android.text.Spanned
import android.text.TextUtils
import android.text.style.ForegroundColorSpan
import com.baojia.mebike.R
import com.baojia.mebike.base.BaseCommonAdapter
import com.baojia.mebike.base.BaseViewHolder
import com.baojia.mebike.data.response.exclusive.IWillExchangeResponse

class IwillExchangeAdapter(activity: Activity, mData: ArrayList<IWillExchangeResponse.DataBean.ListBean>, layoutId: Int)
    : BaseCommonAdapter<IWillExchangeResponse.DataBean.ListBean>(activity, mData, layoutId) {

    override fun convert(holder: BaseViewHolder?, list: MutableList<IWillExchangeResponse.DataBean.ListBean>?, position: Int) {
        val item = list?.get(position)
        item ?: return
        holder?.setImageResource(R.id.backgroundImageView, R.drawable.radius_stroke_line_color)
        if (item.isSelect) {
            holder?.setImageResource(R.id.backgroundImageView, R.drawable.radius_main_color_storke_bg)
        }
        holder?.setText(R.id.contentTextView, item.title)

        holder?.setText(R.id.introduceTextView, item.desc)
        holder?.itemView?.setOnClickListener { onItemChildViewClickListner?.onItemChildViewClick(it, position) }

        if (!TextUtils.isEmpty(item.colorText) && item.desc.contains(item.colorText)) {
            val start = item.desc.indexOf(item.colorText)
            val spanString = SpannableString(item.desc)
            spanString.setSpan(ForegroundColorSpan(Color.parseColor(item.color)), start, start + item.colorText.length, Spanned.SPAN_EXCLUSIVE_EXCLUSIVE)
            holder?.setText(R.id.introduceTextView, spanString)
        }
    }

}
