package com.baojia.mebike.feature.exclusive.iWillExchange

import com.baojia.mebike.data.response.exclusive.IWillExchangeResponse
import com.baojia.mebike.feature.model.IPayPresenter
import com.baojia.mebike.feature.model.IPayView


interface IwillExchangeContract {
    interface View : IPayView<Presenter> {

        fun setData(data: ArrayList<IWillExchangeResponse.DataBean.ListBean>?)

        fun setIntroduceData(title: String?, data: ArrayList<IWillExchangeResponse.DataBean.KnowListBean>?)

        fun getType(): Int

        fun bikeId(): Int
        /**
         * 免费类型，1免费紧急，2免费普通，默认2
         */
        fun subType(): Int

        /**
         * 订单号
         */
        fun orderNo(): String?

        /**
         * 换电升级 18
         */
        fun paymentType(): Int

        fun changeBatteryId(): Long

        /**
         * 显示购买布局文件
         */
        fun showBuyLayout(url:String?)

        /**
         * 显示续期布局文件
         */
        fun showRenewalLayout(buttonValue:String,placeholder:String,title:String)

        /**
         * 更新换电订单号
         */
        fun setOrderNo(orderNo:String?)
    }


    interface Presenter : IPayPresenter {

        /**
         * 获取列表信息
         */
        fun getData()

        /**
         * 换电
         */
        fun exchangePower()

        /**
         * 获取售后信息
         */
        fun getAfterSale()

        fun dataBean(): IWillExchangeResponse.DataBean?
    }
}