package com.baojia.mebike.feature.exclusive.personalChangeBattery

import android.app.Activity
import android.text.TextUtils
import com.baojia.mebike.base.BasePresenter
import com.baojia.mebike.base.aboutbike.AboutBikeModel
import com.baojia.mebike.callback.HttpCallback
import com.baojia.mebike.data.response.bike.BoxInfoResponse
import com.baojia.mebike.data.response.bike.SendBoxInstructResponse
import com.baojia.mebike.data.response.company_personal.PersonalChangeBatteryBoxInfoResponse
import com.baojia.mebike.util.Toast

/**
 * +----------------------------------------------------------------------
 * | @time 2019/1/22:11:27 AM
 * | @author house
 * | @class_describe
 * +----------------------------------------------------------------------
 **/
class PersonalChangeBatteryPresenter(mContext: Activity, var mView: PersonalChangeBatteryContract.View) : BasePresenter(mContext),
        PersonalChangeBatteryContract.Presenter {


    private var model: AboutBikeModel? = null
    // 蓝牙地址
    private var macAddress: String? = null

    init {
        model = AboutBikeModel(mContext)
    }

    override fun sendBox(operation: String) {

        model?.sendBoxInstruct(operation, mView.bikeId(), null, null,true, object : HttpCallback<SendBoxInstructResponse>() {
            override fun onSucceed(data: SendBoxInstructResponse?) {
                super.onSucceed(data)
                // Toast.show(context, data?.message)

                mView.succeed(operation,data?.message)
            }

            override fun onFailed(code: Int, message: String?) {
                super.onFailed(code, message)
                Toast.show(context, message)
            }

            override fun onError(code: Int, message: String?) {
                super.onError(code, message)
                onFailed(code, message)
            }
        })
    }

    override fun getBoxInfo() {
        model?.getBoxInfo(mView.bikeId(), object : HttpCallback<BoxInfoResponse>() {
            override fun onSucceed(data: BoxInfoResponse) {
                super.onSucceed(data)
                if (data.data != null) {
                    macAddress = data.data.btMac
                }
                if (!TextUtils.isEmpty(macAddress)) {
                    mView.setScanRule()
                }
            }
        })
    }

    //90:83:77:38:30:18


    override fun boxMacAddress(): String? = macAddress

}