package com.baojia.mebike.feature.exclusive.shopping.buybikeconfig

import android.app.Activity
import android.content.Intent
import android.os.Bundle
import androidx.fragment.app.Fragment
import com.baojia.mebike.R
import com.baojia.mebike.alipay.AliPayManager
import com.baojia.mebike.base.BaseActivity
import com.baojia.mebike.callback.PayListener
import com.baojia.mebike.data.response.exclusive.shapping.BuyBikeConfigResponse
import com.baojia.mebike.data.response.exclusive.shapping.BuyConfigCommitResponse
import com.baojia.mebike.data.response.order.PayByOtherResponse
import com.baojia.mebike.data.response.shopping.OrderConfirmBean
import com.baojia.mebike.feature.exclusive.shopping.buybikeconfig.fragment.*
import com.baojia.mebike.feature.exclusive.shopping.paysuccess.PaySuccessActivity
import com.baojia.mebike.util.Toast
import com.baojia.mebike.util.ToolBox
import com.baojia.mebike.util.WechatPayUtils
import kotlinx.android.synthetic.main.activity_buy_bike_config.*

open class BuyBikeConfigActivity : BaseActivity(), BuyBikeConfigContract.View, PayListener {
    override fun clickCommit() {
    }


    companion object {
        //goodsType（1：整车购买 2：买车租电 3：整车租赁 , 4直接跳转支付）
        //type（1 直接跳支付 0 不管）
        @JvmStatic
        fun start(activity: Activity, type: Int, bikeTitle: String, maxPower: String, maxSpeed: String, bikeImgUrl: String, goodsType: Int, productId: Int, goodsId: Int, orderNo: String?) {
            val intent = Intent()
            intent.setClass(activity, BuyBikeConfigActivity::class.java)
            intent.putExtra("goodsType", goodsType)
            intent.putExtra("type", type)
            intent.putExtra("productId", productId)
            intent.putExtra("goodsId", goodsId)
            intent.putExtra("orderNo", orderNo)
            intent.putExtra("maxPower", maxPower)
            intent.putExtra("maxSpeed", maxSpeed)
            intent.putExtra("bikeImgUrl", bikeImgUrl)
            intent.putExtra("bikeTitle", bikeTitle)
            activity.startActivity(intent)
        }
    }

    private var currentFragment: Fragment? = Fragment()
    private val plantFragment2 = BuyBikePlantNewFragment()
    private val colorSelectFragment = BuyBikeColorSelectFragment()
    private val getBikeTypeFragment = BuyBikeGetBikeTypeFragment()
    private val orderConfirmFragment = BuyBikeOrderConfirmFragment()
    //4.9.0订单配置页面
    private val buyBikeConfigFragment = BuyBikeConfigFragment()
    //4.9.0订单确认也米娜
    private val buyBikeOrderConfirmNewFragment = BuyBikeOrderConfirmNewFragment()
    private val payFragment = BuyBikePayFragment()

    private var presenter: BuyBikeConfigPresenter? = null
    private var isFirstConfirmOrder = true

    //（1：整车购买 2：买车租电 3：整车租赁 ）
    private var goodsType = 0
    //（1 直接跳支付 0 不管）
    private var type = 0
    private var goodsId = 0
    private var productId = 0
    private var orderNo = ""
    open var bikeImgUrl = ""
    open var maxPower = ""
    open var maxSpeed = ""
    open var bikeTitle = ""
    private var takeLongitude = 0.0
    private var takeLatitude = 0.0
    //收车人姓名
    private var takeUserName = ""
    //收车人电话
    private var takeUserPhone = ""
    //收车人地址备注
    private var takeUserAddr = ""
    //收车人地址
    private var takeUserAddrRemarks = ""
    //取车方式（1：上门送货 2：自行取车）
    private var takeType = 1
    // 支付方式 1：微信支付 2：支付宝支付
    private var payMethod = 1
    //取车位置选中位置
    open var takeTypeSelectPosition = 0
    //颜色选中位置
    open var colorSelectPosition = 0
    //专享期限选中位置
//    open var deadTimeSelectPosition = -1
    //紧急换电选中位置
//    open var changePowerSelectPosition = -1
    //总数据

    open var dataBean: BuyBikeConfigResponse.DataBean? = null

    open var dialogData :OrderConfirmBean = OrderConfirmBean("","","",0.00, arrayListOf())

    override fun layoutId(): Int = R.layout.activity_buy_bike_config

    override fun isVisibleTitleBar(): Boolean = true

    override fun bindView(savedInstanceState: Bundle?) {
        intent?.let {
            type = it.getIntExtra("type", 0)
            goodsType = it.getIntExtra("goodsType", 0)
            goodsId = it.getIntExtra("goodsId", 0)
            productId = it.getIntExtra("productId", 0)
            orderNo = it.getStringExtra("orderNo")
            maxSpeed = it.getStringExtra("maxSpeed")
            bikeImgUrl = it.getStringExtra("bikeImgUrl")
            maxPower = it.getStringExtra("maxPower")
            bikeTitle = it.getStringExtra("bikeTitle")
        }

        dialogData.title = bikeTitle
        dialogData.bikeImgUrl = bikeImgUrl


        presenter = BuyBikeConfigPresenter(this, this)
        presenter?.getAllData()

        switchFragment(buyBikeConfigFragment)


    }


    override fun setLeftButtonOnClickListener() {
        onBackPressed()
    }


    override fun onBackPressed() {
        if (currentFragment is BuyBikeOrderConfirmNewFragment){
            switchFragment(buyBikeConfigFragment)
        }else {
            super.setLeftButtonOnClickListener()
        }
    }


    //fragment取消按钮
    open fun clickCancle() {
//        if (currentFragment is BuyBikePlantNewFragment) {
//            finish()
//        } else if (currentFragment is BuyBikeColorSelectFragment) {
//            switchFragment(plantFragment2)
//        } else if (currentFragment is BuyBikeGetBikeTypeFragment) {
//            switchFragment(colorSelectFragment)
//        } else if (currentFragment is BuyBikeOrderConfirmFragment) {
//            switchFragment(getBikeTypeFragment)
//        } else if (currentFragment is BuyBikePayFragment) {
////            switchFragment(payFragment)
//        }
    }

    //fragment确定按钮
    open fun clickOk() {
        if (currentFragment is BuyBikeConfigFragment) {
            switchFragment(buyBikeOrderConfirmNewFragment)
        } else if (currentFragment is BuyBikeOrderConfirmNewFragment) {
            presenter?.buyConfigCommit()
        }
    }

    //tabfragment，切换
    private fun switchFragment(targetFragment: Fragment) {
        if (currentFragment === targetFragment) {
            return
        }
        val transaction = supportFragmentManager.beginTransaction()
        currentFragment?.let {
            transaction.hide(it)
        }
        if (!targetFragment.isAdded) {
            transaction.add(R.id.buyBikeConfigFrameLayout, targetFragment)
                    .commitAllowingStateLoss()
        } else {
            transaction
                    .show(targetFragment)
                    .commitAllowingStateLoss()
        }
        currentFragment = targetFragment
//        changAllTabSmall()
        if (currentFragment is BuyBikeConfigFragment) {
            setTitle(dialogData.title)
        } else if (currentFragment is BuyBikeOrderConfirmNewFragment) {
            setTitle("订单确认")
        }

    }

    //tab字体处理
    private fun changAllTabSmall() {
        buyBikeServiceTv.textSize = 15f
        buyBikeColorTv.textSize = 15f
        buyBikeGetTypeTv.textSize = 15f
        buyBikeOrderConfirmTv.textSize = 15f
        buyBikeOrderPayTv.textSize = 15f
        buyBikeServiceTv.setTextColor(ToolBox.getColor(R.color.text_second_color))
        buyBikeColorTv.setTextColor(ToolBox.getColor(R.color.text_second_color))
        buyBikeGetTypeTv.setTextColor(ToolBox.getColor(R.color.text_second_color))
        buyBikeOrderConfirmTv.setTextColor(ToolBox.getColor(R.color.text_second_color))
        buyBikeOrderPayTv.setTextColor(ToolBox.getColor(R.color.text_second_color))
    }

    override fun onResume() {
        super.onResume()
        if (currentFragment is BuyBikeOrderConfirmNewFragment) {
            checkPay()
        }
    }

    override fun orderPaySucceed(dataBean: PayByOtherResponse.DataBean) {
        if (dataBean.payChannelId == 1) {
            WechatPayUtils.wechatPay(this, dataBean.appid, dataBean.partnerid, dataBean.prepayid,
                    dataBean.wxpackage, dataBean.noncestr, dataBean.timestamp,
                    dataBean.sign)

        } else if (dataBean.payChannelId == 2) {
            AliPayManager(this)
                    .alipayV2(this, dataBean.orderInfo)
        }
    }

    override fun onFailed(msg: String?) {
        Toast.show(this, msg)
    }

    override fun onSuccess() {
    }

    override fun paySuccess() {
        PaySuccessActivity.startActivity(this,orderNo)
    }


    override fun payMethod(): Int = payMethod

    override fun goodsType(): Int = goodsType

    override fun productColorId(): Int {
        dataBean?.colors?.let {
            if (colorSelectPosition == -1) {
                return -1
            }
            return it[colorSelectPosition].colorId
        }
        return -1
    }

    override fun takeType(): Int = takeType

    override fun packageItemIds(): String {
        var ids = ""
        dataBean?.packages?.let {
            for (index in it.indices) {
                for (indexIn in it[index].packageItems.indices) {
                    if (it[index].packageItems[indexIn].isClick) {
                        ids = ids + it[index].packageItems[indexIn].packageItemId + ","
                    }
                }
            }

        }
        if (ids.isNotEmpty()) {
            ids = ids.substring(0, ids.length - 1)
        }
        return ids
    }

    override fun takeUserName(): String = takeUserName

    override fun takeUserPhone(): String = takeUserPhone

    override fun takeUserAddrRemarks(): String = takeUserAddrRemarks

    override fun takeUserAddr(): String = takeUserAddr

    override fun productId(): Int = productId

    override fun goodsId(): Int = goodsId

    override fun orderNo(): String = orderNo
    override fun setOrderNo(orderNo: String) {
        this.orderNo = orderNo
    }

    override fun takeLongitude() = takeLongitude

    override fun takeLatitude() = takeLatitude

    override fun setPresenter(presenter: BuyBikeConfigContract.Presenter?) {
    }


    override fun onActivityResult(requestCode: Int, resultCode: Int, data: Intent?) {
        super.onActivityResult(requestCode, resultCode, data)
        if (requestCode == 66 && resultCode == 12) {
            data?.let {
                takeUserAddr = it.getStringExtra("address")
                takeUserAddrRemarks = it.getStringExtra("desc")
                takeUserName = it.getStringExtra("name")
                takeUserPhone = it.getStringExtra("phone")
                takeLatitude = it.getDoubleExtra("takeLatitude", 0.0)
                takeLongitude = it.getDoubleExtra("takeLongitude", 0.0)
                buyBikeOrderConfirmNewFragment.setActivityResultData(takeUserAddr,takeUserName,takeUserPhone)
//                Toast.show(this, "${it.getStringExtra("address")} ${it.getStringExtra("desc")}")
            }
        }
    }

    //取车回调（1：上门送货 2：自行取车）
    fun setTakeType(takeType: Int) {
        this.takeType = takeType
    }

    fun setPayType(payType: Int) {
        this.payMethod = payType
    }

    //查单
    fun checkPay() {
        presenter?.checkOrderPayStatus()
    }

    //获取支付页面数据
    fun getPayDetail() {
        presenter?.payDetailData()
    }

    //修改plant页面原始数据
    fun changePlantData(one: Int, two: Int, isClick: Boolean) {
        dataBean?.packages?.let {
            it[one].packageItems[two].isClick = isClick
        }
    }

    override fun setAllData(dataBean: BuyBikeConfigResponse.DataBean) {
        this.dataBean = dataBean
        dataBean.packages?.let {
            //设置默认选中第一个
            for (index in it.indices) {
                if (it[index].required == 1) {
                    it[index].packageItems[0].isClick = true
                    this.dataBean!!.packages[index].packageItems[0].isClick = true
                }
            }

        }

        if (currentFragment is BuyBikeConfigFragment) {
            buyBikeConfigFragment.refreshData()
        }
        if (currentFragment is BuyBikeOrderConfirmNewFragment) {
            buyBikeOrderConfirmNewFragment.refreshData()
        }
    }

    override fun setPayDetailData(dataBean: BuyConfigCommitResponse.DataBeanX) {
        if (currentFragment is BuyBikePayFragment) {
            payFragment.setData(dataBean)
        }
    }

}