package com.baojia.mebike.feature.exclusive.shopping.buybikeconfig

import android.content.Context
import android.os.Bundle
import android.view.View
import androidx.fragment.app.FragmentManager
import androidx.recyclerview.widget.LinearLayoutManager
import com.baojia.mebike.R
import com.baojia.mebike.base.BaseCompatDialogFragment
import com.baojia.mebike.data.CommData
import com.baojia.mebike.data.response.shopping.OrderConfirmItemBean
import kotlinx.android.synthetic.main.dialog_order_confirm.*
import kotlinx.android.synthetic.main.layout_buy_bike_bottom_money.*


//订单确认弹框
class OrderConfirmInfoDialog : BaseCompatDialogFragment() {


    var totalMoney = 0.00
    var infoList = arrayListOf<OrderConfirmItemBean>()
    var onBuyClickListener: OnBuyClickListener? = null

    override fun setContentView(): Int {
        return R.layout.dialog_order_confirm
    }

    override fun bindView() {

        setDialogBottom()

        totalMoney = bundle.getDouble("totalMoney")
        infoList.clear()
        infoList.addAll(bundle.getParcelableArrayList("infoList"))

        orderDialogRecyclerView.layoutManager = LinearLayoutManager(activity)
        orderDialogRecyclerView.adapter = OrderConfirmInfoAdapter(activity, infoList, R.layout.item_order_confrim_info)

        buyBikeBottomViewMoneyTv.text = "￥$totalMoney"
        buyBikeBottomViewOkTv.text = "购买"
        setViewClickDuration(buyBikeBottomViewOkTv, 1)
        setViewClickDuration(orderDialogBottomLayout, 1)


    }


    override fun getStyle(): Int {
        return R.style.BottomAnimateDialog
    }

    override fun getWidth(): Int {
        return CommData.getScreen()[0]
    }

    override fun setViewClick(view: View?) {
        super.setViewClick(view)
        if (buyBikeBottomViewOkTv == view) {
            dismiss()
            onBuyClickListener?.onBuyClick()
        }
        if (orderDialogBottomLayout == view) {
            dismiss()
        }

    }

    companion object {
        @JvmStatic
        fun show(mContext: Context?, fragmentManager: FragmentManager?, totalMoney: Double, infoList: ArrayList<OrderConfirmItemBean>?) {
            mContext ?: return
            fragmentManager ?: return
            var bundle = Bundle()
            bundle.putDouble("totalMoney", totalMoney)
            bundle.putParcelableArrayList("infoList", infoList)
            val orderConfirmInfoDialog = OrderConfirmInfoDialog()
            orderConfirmInfoDialog.arguments = bundle
            orderConfirmInfoDialog.show(fragmentManager, "OrderConfirmInfoDialog")
        }
    }

    interface OnBuyClickListener {
        fun onBuyClick()
    }

}