package com.baojia.mebike.feature.exclusive.shopping.buybikeconfig.fragment

import android.os.Bundle
import android.view.View
import android.widget.ImageView
import android.widget.TextView
import androidx.recyclerview.widget.GridLayoutManager
import androidx.recyclerview.widget.LinearLayoutManager
import androidx.recyclerview.widget.RecyclerView
import com.baojia.mebike.R
import com.baojia.mebike.base.BaseFragmentNew
import com.baojia.mebike.data.response.exclusive.shapping.BuyBikeConfigResponse
import com.baojia.mebike.data.response.shopping.OrderConfirmItemBean
import com.baojia.mebike.feature.exclusive.shopping.buybikeconfig.*
import com.baojia.mebike.util.JumpActivity
import com.baojia.mebike.util.Toast
import kotlinx.android.synthetic.main.fragment_buy_bike_plant_new.*
import kotlinx.android.synthetic.main.layout_buy_bike_bottom_money.*
import java.text.DecimalFormat

//4.9.0订单配置页面
class BuyBikeConfigFragment : BaseFragmentNew() {
    override fun layoutId(): Int = R.layout.fragment_buy_bike_plant_new

    private var packageData: ArrayList<BuyBikeConfigResponse.DataBean.PackagesBean>? = arrayListOf()
    private var mData = arrayListOf<BuyBikeConfigResponse.DataBean.ColorsBean>()
    private var titleData = arrayListOf<BuyBikeConfigResponse.DataBean.BikePricesBean>()
    private var adapter: ColorSelectAdapter<BuyBikeConfigResponse.DataBean.ColorsBean>? = null
    private var titleAdapter: BuyBikeTitleAdapter? = null
    //现 总价
    var allPrice = 0.00
    //上一次价钱   动画需要
    var oldPrice = 0.00
    private val fnum = DecimalFormat("##0.00")

    override fun bindView() {

        buyBikeBottomViewOkTv.text = "购买"
        buyBikeBottomViewMoneyChangeTv.visibility = View.VISIBLE
        buyBikeBottomViewMoneyTv.visibility = View.INVISIBLE

        setViewClickDuration(buyBikeBottomViewOkTv, 1)
        setViewClickDuration(buyBikePlantBottomLayout, 1)

        titleRecyclerView.layoutManager = LinearLayoutManager(activity)
        titleAdapter = BuyBikeTitleAdapter(activity,titleData,R.layout.item_buy_bike_info)
        titleRecyclerView.adapter = titleAdapter


    }

    override fun setViewClick(view: View?) {
        super.setViewClick(view)
        when (view) {
            buyBikeBottomViewOkTv -> {
                var isReturn = false
                packageData?.let {
                    for (index in it.indices) {
                        if (it[index].required == 1) {
                            var isClicked = false
                            for (indexIn in it[index].packageItems) {
                                if (indexIn.isClick) {
                                    isClicked = true
                                }
                            }
                            if (!isClicked) {
                                Toast.show(activity, "请${it[index].packageName}")
                                isReturn = true
                                return@let
                            }

                        }
                    }
                }
                if (isReturn) return
                getFatherActivity()?.clickOk()
            }

            //弹已选择对话框
            buyBikePlantBottomLayout -> {
                getFatherActivity()?.dialogData?.let {
                    if (it.listData.isEmpty()) {
                        return@let
                    }
                    var bundle = Bundle()
                    bundle.putDouble("totalMoney", allPrice)
                    bundle.putParcelableArrayList("infoList", it.listData)
                    val orderConfirmInfoDialog = OrderConfirmInfoDialog()
                    orderConfirmInfoDialog.arguments = bundle
                    orderConfirmInfoDialog.show(fragmentManager, "OrderConfirmInfoDialog")
                    orderConfirmInfoDialog.onBuyClickListener = object : OrderConfirmInfoDialog.OnBuyClickListener {
                        override fun onBuyClick() {
                            buyBikeBottomViewOkTv.performClick()
                        }
                    }
                }

            }

        }
    }

    open fun refreshData() {


        getFatherActivity()?.dataBean?.let {
            //颜色
            it.colors?.let {
                mData.clear()
                mData.addAll(it)
                if (mData.isNotEmpty()) {
                    mData[0].isClick = true
                    getFatherActivity()?.dialogData?.color = mData[0].name
                }
                //车辆颜色view添加
                var view = layoutInflater.inflate(R.layout.item_buy_bike_plant_new, null)
                val recyclerView = view.findViewById<RecyclerView>(R.id.buyBikePlantRushTimeRecyclerView)
                val titleView = view.findViewById<TextView>(R.id.buyBikePlantRushTimeTv)
                val buyBikePlantTypeTv = view.findViewById<TextView>(R.id.buyBikePlantTypeTv)
                //详情icon
                val buyBikePlantRushTimeDetailIv = view.findViewById<ImageView>(R.id.buyBikePlantRushTimeDetailIv)
                //详情
                val buyBikePlantRushTimeDetailTv = view.findViewById<TextView>(R.id.buyBikePlantRushTimeDetailTv)
                buyBikePlantTypeTv.visibility = View.GONE
                buyBikePlantRushTimeDetailIv.visibility = View.GONE
                buyBikePlantRushTimeDetailTv.visibility = View.GONE

                titleView.text = "车辆颜色"

                recyclerView.layoutManager = GridLayoutManager(activity, 4)
                adapter = ColorSelectAdapter<BuyBikeConfigResponse.DataBean.ColorsBean>(activity, mData, R.layout.item_color_select)
                recyclerView.adapter = adapter
                adapter?.setOnItemClickListner { _, position ->
                    run {
                        if (mData.isEmpty()) return@setOnItemClickListner
                        for (item in mData) {
                            item.isClick = false
                        }
                        mData[position].isClick = true
                        getFatherActivity()?.colorSelectPosition = position
                        getFatherActivity()?.dialogData?.color = mData[position].name
                        adapter?.notifyDataSetChanged()
                    }
                }
                buyBikePlantLinearLayout.addView(view)
                adapter?.notifyDataSetChanged()
            }
            //套餐
            it.packages?.let {
                packageData?.clear()
                packageData?.addAll(it)

            }

            //产品列表
            it.bikePrices?.let {
                titleData.clear()
                titleData.addAll(it)
                titleAdapter?.notifyDataSetChanged()

            }
        }

        packageData?.let {
            //有必选的  提前设置金额
            initDialogList()

            //一个套餐对应一个view
            for (index in it.indices) {
                var deadTimeAdapter = BuyBikePlantAdapter(it[index].required, activity, it[index].packageItems, R.layout.item_buy_bike_plant)
                var view = layoutInflater.inflate(R.layout.item_buy_bike_plant_new, null)
                val recyclerView = view.findViewById<RecyclerView>(R.id.buyBikePlantRushTimeRecyclerView)
                //骑行无忧套餐
                val titleView = view.findViewById<TextView>(R.id.buyBikePlantRushTimeTv)
                //详情icon
                val buyBikePlantRushTimeDetailIv = view.findViewById<ImageView>(R.id.buyBikePlantRushTimeDetailIv)
                //详情
                val buyBikePlantRushTimeDetailTv = view.findViewById<TextView>(R.id.buyBikePlantRushTimeDetailTv)
                //车辆租期,必选   描述文字
                val buyBikePlantRushTimeDescTv = view.findViewById<TextView>(R.id.buyBikePlantRushTimeDescTv)
                //增值服务(可选)
                val buyBikePlantTypeTv = view.findViewById<TextView>(R.id.buyBikePlantTypeTv)
                buyBikePlantRushTimeDescTv.text = it[index].packageDescription

                if (it[index].required == 1){
                    buyBikePlantTypeTv.visibility = View.GONE
                }else{
                    if (index == 0){
                        buyBikePlantTypeTv.visibility = View.VISIBLE
                    }else{
                        if (it[index].required == it[index-1].required){
                            buyBikePlantTypeTv.visibility = View.GONE
                        }else{
                            buyBikePlantTypeTv.visibility = View.VISIBLE
                        }
                    }
                }


                titleView.text = it[index].packageName
                recyclerView.layoutManager = GridLayoutManager(activity, 2)
                recyclerView.adapter = deadTimeAdapter

                deadTimeAdapter.setOnItemClickListner { _, position ->
                    run {
                        //增长动画没结束点击失效
                        if (buyBikeBottomViewMoneyChangeTv.isRunning()) {
                            return@setOnItemClickListner
                        }
                        var isClick = it[index].packageItems[position].isClick
                        if (it[index].required == 1 && isClick) {
                            return@run
                        }
                        for (index2 in it[index].packageItems.indices) {
                            it[index].packageItems[index2].isClick = false
                        }
                        it[index].packageItems[position].isClick = !isClick
                        getFatherActivity()?.changePlantData(index, position, !isClick)
                        initDialogList()

                        deadTimeAdapter.notifyDataSetChanged()
                    }
                }
                //条目详情跳转
                buyBikePlantRushTimeDetailTv.setOnClickListener(fun(_: View?) {
                    JumpActivity.JumpWebView(activity,it[index].packageName ,it[index].packageUrl)
                })
                buyBikePlantRushTimeDetailIv.setOnClickListener(fun(_: View?) {
                    JumpActivity.JumpWebView(activity,it[index].packageName ,it[index].packageUrl)
                })
                buyBikePlantLinearLayout.addView(view)
            }
        }


    }

    @Synchronized
    private fun initDialogList() {
        allPrice = 0.00
        var itemList = arrayListOf<OrderConfirmItemBean>()
        itemList.clear()
        titleData?.let {
            for (item in it){
                allPrice+=item.price
                var desc = ""
                if (item.placeholder != null && item.placeholder.isNotEmpty()){
                    desc = "(${item.placeholder})"
                }
                itemList.add(OrderConfirmItemBean(item.title, desc, item.priceText, ""))
            }
        }
        packageData?.let {
            for (moneyIndex in it.indices) {
                if (it[moneyIndex].packageItems == null && it[moneyIndex].packageItems.isEmpty()){
                    return@let
                }
                for (moneyIndex2 in it[moneyIndex].packageItems.indices) {
                    if (it[moneyIndex].packageItems[moneyIndex2].isClick) {
                        var itemData = it[moneyIndex].packageItems[moneyIndex2]
                        allPrice += itemData.currentPrice
                        itemList.add(OrderConfirmItemBean(it[moneyIndex].packageName,
                                "",
                                it[moneyIndex].packageItems[moneyIndex2].currentPriceText,
                                "${it[moneyIndex].packageItems[moneyIndex2].description}"))

                    }
                }
            }
            allPrice = fnum.format(allPrice).toDouble()
            buyBikeBottomViewMoneyTv.text = "￥$allPrice"
            buyBikeBottomViewMoneyChangeTv.setFloat(oldPrice.toFloat(), allPrice.toFloat())
            buyBikeBottomViewMoneyChangeTv.setDuration(600)
            buyBikeBottomViewMoneyChangeTv.start()
            oldPrice = allPrice
            getFatherActivity()?.dialogData?.totalMoney = allPrice
            getFatherActivity()?.dialogData?.listData = itemList
        }
    }


    fun getFatherActivity(): BuyBikeConfigActivity? = activity as BuyBikeConfigActivity
}