package com.baojia.mebike.feature.exclusive.shopping.buybikeconfig.fragment

import android.app.Activity
import android.graphics.Paint
import android.os.Bundle
import android.view.View
import android.view.animation.AnimationUtils
import androidx.recyclerview.widget.LinearLayoutManager
import com.baojia.mebike.R
import com.baojia.mebike.base.BaseLazyLoadFragment
import com.baojia.mebike.feature.exclusive.shopping.backAddress.InputBackAddressActivity
import com.baojia.mebike.feature.exclusive.shopping.buybikeconfig.BuyBikeConfigActivity
import com.baojia.mebike.feature.exclusive.shopping.buybikeconfig.OrderConfirmInfoAdapter
import com.baojia.mebike.feature.exclusive.shopping.nearBike.NearBikeActivity
import com.baojia.mebike.feature.exclusive.shopping.near_shop.NearShopActivity
import com.baojia.mebike.imageloader.ImageLoader
import com.baojia.mebike.util.JumpActivity
import com.baojia.mebike.util.Toast
import com.baojia.mebike.util.ToolBox
import kotlinx.android.synthetic.main.fragment_shopping_order_confirm.*
import kotlinx.android.synthetic.main.include_payment.*
import kotlinx.android.synthetic.main.item_buy_bike_info.*
import kotlinx.android.synthetic.main.layout_buy_bike_bottom_money.*

//4.9.0 订单确认页面
class BuyBikeOrderConfirmNewFragment : BaseLazyLoadFragment() {

    override fun layoutId(): Int = R.layout.fragment_shopping_order_confirm

    // 支付方式 1：微信支付 2：支付宝支付
    private var payMethod = 1
    var isAddressReturn = false
    var isCheckedProtocal = true
    var selectType = 1
    var oldSelectType = 1

    override fun loadData() {
        refreshData()
    }

    override fun isNeedReload(): Boolean = true

    override fun bindView() {

        paymentTitleTextView.visibility = View.GONE

        buyBikeBottomViewOkTv.text = "立即支付"
        orderConfirmCheckProtocolTv.getPaint().setFlags(Paint.UNDERLINE_TEXT_FLAG)
        setPayMethod(1)

        setViewClickDuration(wechatPayLayout, 1)
        setViewClickDuration(aliPayLayout, 1)
        setViewClickDuration(buyBikeBottomViewOkTv, 1)
        setViewClickDuration(orderConfirmTypeOneTv, 1)
        setViewClickDuration(orderConfirmTypeTwoTv, 1)
        setViewClickDuration(orderConfirmTypeThreeTv, 1)
        setViewClickDuration(orderConfirmTypeOneNoneConsl, 1)
        setViewClickDuration(orderConfirmTypeOneConsl, 1)
        setViewClickDuration(orderConfirmTypeTwoConsl, 1)
        setViewClickDuration(orderConfirmTypeThirdConsl, 1)
        setViewClickDuration(orderConfirmCheckProtocolIv, 1)
        setViewClickDuration(orderConfirmCheckProtocolTv, 1)

        refreshData()

    }

    override fun setViewClick(view: View?) {
        super.setViewClick(view)
        when (view) {
            wechatPayLayout -> setPayMethod(1)
            aliPayLayout -> setPayMethod(2)
            buyBikeBottomViewOkTv -> {
                if (!isCheckedProtocal) {
                    Toast.show(activity, "请查看并同意购买协议")
                    return
                }
                if (selectType == 1 && !isAddressReturn) {
                    Toast.show(activity, "请填写送车上门地址")
                    return
                }
                getFatherActivity()?.clickOk()
            }

            //地址选择
            orderConfirmTypeOneConsl, orderConfirmTypeOneNoneConsl -> {
                InputBackAddressActivity.startForResult(activity as BuyBikeConfigActivity, 66, getFatherActivity()?.takeUserAddr()
                        , getFatherActivity()?.takeUserName(), getFatherActivity()?.takeUserPhone(), getFatherActivity()?.takeUserAddrRemarks()
                        , getFatherActivity()?.takeLatitude(), getFatherActivity()?.takeLongitude())
            }
            //自行取车跳转
            orderConfirmTypeTwoConsl -> {
                NearBikeActivity.start(activity as Activity, null, Bundle(), 0, getFatherActivity()?.productId()?.toLong(), getFatherActivity()?.productColorId())
            }
            //门店自提跳转
            orderConfirmTypeThirdConsl -> {
                activity?.let {
                    NearShopActivity.start(it)
                }
            }
            //送车上门按钮
            orderConfirmTypeOneTv -> {
                changeSelectType(1)
            }
            //自行取车按钮
            orderConfirmTypeTwoTv -> {
                changeSelectType(2)
            }
            //门店自提按钮
            orderConfirmTypeThreeTv -> {
                changeSelectType(3)
            }
            orderConfirmCheckProtocolIv -> {
                isCheckedProtocal = !isCheckedProtocal
                if (isCheckedProtocal) {
                    orderConfirmCheckProtocolIv.setBackgroundResource(R.mipmap.selected_icon)
                } else {
                    orderConfirmCheckProtocolIv.setBackgroundResource(R.mipmap.unselected_icon)
                }
            }
            //购买协议
            orderConfirmCheckProtocolTv -> {
                JumpActivity.JumpWebView(activity,"",getFatherActivity()?.dataBean?.protocolUrl)
            }

        }
    }

    fun changeSelectType(type: Int) {
        if (type == oldSelectType){
            return
        }
        selectType = type
        val animationIn = AnimationUtils.loadAnimation(activity, R.anim.slide_in_from_left)
        val animationOut = AnimationUtils.loadAnimation(activity, R.anim.slide_out_to_right)
        animationOut.repeatCount = 1
        animationOut.duration = 200
        animationIn.repeatCount = 1
        animationIn.duration = 200
        orderConfirmTypeOneTv.setTextColor(ToolBox.getColor(R.color.text_second_color))
        orderConfirmTypeTwoTv.setTextColor(ToolBox.getColor(R.color.text_second_color))
        orderConfirmTypeThreeTv.setTextColor(ToolBox.getColor(R.color.text_second_color))
        orderConfirmTypeOneTv.setBackgroundResource(R.drawable.d_radius_button_bg_select)
        orderConfirmTypeTwoTv.setBackgroundResource(R.drawable.d_radius_button_bg_select)
        orderConfirmTypeThreeTv.setBackgroundResource(R.drawable.d_radius_button_bg_select)
        orderConfirmTypeOneConsl.visibility = View.INVISIBLE
        orderConfirmTypeOneNoneConsl.visibility = View.INVISIBLE
        orderConfirmTypeTwoConsl.visibility = View.INVISIBLE
        orderConfirmTypeThirdConsl.visibility = View.INVISIBLE
        when (oldSelectType) {
            //送车上门
            1 -> {
                if (isAddressReturn) {
                    orderConfirmTypeOneConsl.startAnimation(animationOut)
                } else {
                    orderConfirmTypeOneNoneConsl.startAnimation(animationOut)
                }
            }
            //自行取车
            2 -> {
                orderConfirmTypeTwoConsl.startAnimation(animationOut)
            }
            //门店自提
            3 -> {
                orderConfirmTypeThirdConsl.startAnimation(animationOut)
            }

        }

        when (type) {
            //送车上门
            1 -> {
                if (isAddressReturn) {
                    orderConfirmTypeOneConsl.visibility = View.VISIBLE
                    orderConfirmTypeOneConsl.startAnimation(animationIn)
                } else {
                    orderConfirmTypeOneNoneConsl.visibility = View.VISIBLE
                    orderConfirmTypeOneNoneConsl.startAnimation(animationIn)
                }
                orderConfirmTypeOneTv.setTextColor(ToolBox.getColor(R.color.text_first_color))
                orderConfirmTypeOneTv.setBackgroundResource(R.drawable.a_radius_button_bg_unselect)
                getFatherActivity()?.setTakeType(1)
            }
            //自行取车
            2 -> {
                orderConfirmTypeTwoTv.setTextColor(ToolBox.getColor(R.color.text_first_color))
                orderConfirmTypeTwoTv.setBackgroundResource(R.drawable.a_radius_button_bg_unselect)
                orderConfirmTypeTwoConsl.visibility = View.VISIBLE
                orderConfirmTypeTwoConsl.startAnimation(animationIn)
                getFatherActivity()?.setTakeType(2)
            }
            //门店自提
            3 -> {
                orderConfirmTypeThreeTv.setTextColor(ToolBox.getColor(R.color.text_first_color))
                orderConfirmTypeThreeTv.setBackgroundResource(R.drawable.a_radius_button_bg_unselect)
                orderConfirmTypeThirdConsl.visibility = View.VISIBLE
                orderConfirmTypeThirdConsl.startAnimation(animationIn)
                getFatherActivity()?.setTakeType(3)
            }

        }

        oldSelectType = selectType
    }

    private fun setPayMethod(payWay: Int) {
        if (payWay == 1) {
            // 微信支付
            wechatSelectImageView.setImageResource(R.mipmap.selected_icon)
            aliSelectImageView.setImageResource(R.mipmap.unselected_icon)
        } else {
            // 支付宝支付
            aliSelectImageView.setImageResource(R.mipmap.selected_icon)
            wechatSelectImageView.setImageResource(R.mipmap.unselected_icon)
        }
        payMethod = payWay
        getFatherActivity()?.setPayType(payWay)
    }

    open fun refreshData() {
        getFatherActivity()?.dialogData?.let {

            buyBikeBottomViewMoneyTv.text = "￥${it.totalMoney}"
            ImageLoader.loadUrl(goodsImageIv, it.bikeImgUrl)
            goodsTitleTv.text = it.title
            goodsMoney.text = it.color
            orderConfirmRecyclerView.layoutManager = LinearLayoutManager(activity)
            orderConfirmRecyclerView.adapter = OrderConfirmInfoAdapter(activity, it.listData, R.layout.item_order_confrim_info)
        }

        getFatherActivity()?.dataBean?.takeType?.let {
            for (item in it) {
                when (item.tag) {
                    1 -> {
                        orderConfirmTypeOneTv.visibility = View.VISIBLE
                    }
                    2 -> {
                        orderConfirmTypeTwoTv.visibility = View.VISIBLE
                    }
                    3 -> {
                        orderConfirmTypeThreeTv.visibility = View.VISIBLE
                    }

                }
            }

        }

    }

    open fun setActivityResultData(address: String, name: String, phone: String) {
        isAddressReturn = true
        orderConfirmTypeOneTitleTv.text = "$name  $phone"
        orderConfirmTypeOneDescTv.text = address
        orderConfirmTypeOneConsl.visibility = View.VISIBLE
        orderConfirmTypeOneNoneConsl.visibility = View.INVISIBLE
    }

    fun getFatherActivity(): BuyBikeConfigActivity? = activity as BuyBikeConfigActivity

}