package com.baojia.mebike.feature.exclusive.shopping.buybikeconfig.fragment

import android.view.View
import android.widget.TextView
import androidx.recyclerview.widget.GridLayoutManager
import androidx.recyclerview.widget.RecyclerView
import com.baojia.mebike.R
import com.baojia.mebike.base.BaseFragmentNew
import com.baojia.mebike.feature.exclusive.shopping.buybikeconfig.BuyBikeConfigActivity
import com.baojia.mebike.data.response.exclusive.shapping.BuyBikeConfigResponse
import com.baojia.mebike.feature.exclusive.shopping.buybikeconfig.BuyBikePlantAdapter
import com.baojia.mebike.imageloader.ImageLoader
import com.baojia.mebike.util.CommonUtils
import com.baojia.mebike.util.JumpActivity
import com.baojia.mebike.util.Toast
import kotlinx.android.synthetic.main.fragment_buy_bike_plant.*
import kotlinx.android.synthetic.main.fragment_buy_bike_plant_new.*
import kotlinx.android.synthetic.main.layout_buy_bike_bottom.*
import kotlinx.android.synthetic.main.layout_buy_bike_info.*

class BuyBikePlantNewFragment : BaseFragmentNew() {
    override fun layoutId(): Int = R.layout.fragment_buy_bike_plant_new

    private var packageData: ArrayList<BuyBikeConfigResponse.DataBean.PackagesBean>? = arrayListOf()

    override fun bindView() {

//        buyBikeBottomViewOkRightTv.text = "确认服务套餐"
//
//        setViewClickDuration(buyBikeBottomViewOkLeftTv, 1)
//        setViewClickDuration(buyBikeBottomViewOkRightTv, 1)
//        setViewClickDuration(buyBikePlantDetailTv, 1)
        refreshData()

    }

    override fun setViewClick(view: View?) {
        super.setViewClick(view)
        when (view) {
            buyBikeBottomViewOkLeftTv -> activity?.finish()
            buyBikeBottomViewOkRightTv ->{
                var isReturn = false
                packageData?.let {
                    for (index in it.indices){
                        if (it[index].required == 1){
                            var isClicked = false
                            for (indexIn in it[index].packageItems){
                                if (indexIn.isClick){
                                    isClicked = true
                                }
                            }
                            if (!isClicked){
                                Toast.show(activity,"请${it[index].packageName}")
                                isReturn = true
                                return@let
                            }

                        }
                    }
                }
                if (isReturn)return
              getFatherActivity()?.clickOk()
            }
            buyBikePlantDetailTv ->{
                JumpActivity.JumpWebView(activity,getFatherActivity()?.dataBean?.urlTitle,getFatherActivity()?.dataBean?.url)
            }

        }
    }

    open fun refreshData() {

        ImageLoader.loadUrl(bugBikePicImageView, getFatherActivity()?.bikeImgUrl, R.drawable.pic_bike_buy)
        buyBikeInfoLeftContentTv.text = getFatherActivity()?.maxSpeed
        buyBikeInfoRightContentTv.text = getFatherActivity()?.maxPower

        getFatherActivity()?.dataBean?.packages?.let {
            packageData?.clear()
            packageData?.addAll(it)

        }
        packageData?.let {
            //一个套餐对应一个view
            for (index in it.indices) {
                var deadTimeAdapter = BuyBikePlantAdapter(it[index].required,activity, it[index].packageItems , R.layout.item_buy_bike_plant)
                var view =  layoutInflater.inflate(R.layout.item_buy_bike_plant_new,null)
                val recyclerView = view.findViewById<RecyclerView>(R.id.buyBikePlantRushTimeRecyclerView)
                val titleView = view.findViewById<TextView>(R.id.buyBikePlantRushTimeTv)
                val buyBikePlantTypeTv = view.findViewById<TextView>(R.id.buyBikePlantTypeTv)
                if (index == 1){
                    buyBikePlantTypeTv.visibility = View.GONE
                }
                titleView.text = it[index].packageName
                recyclerView.layoutManager = GridLayoutManager(activity,2)
                recyclerView.adapter = deadTimeAdapter
                deadTimeAdapter.setOnItemClickListner { _, position ->
                    run {
                        var isClick = it[index].packageItems[position].isClick
                        if (it[index].required == 1 && isClick){
                            return@run
                        }
                        for (index2 in it[index].packageItems.indices) {
                            it[index].packageItems[index2].isClick = false
                        }
                        it[index].packageItems[position].isClick = !isClick
                        getFatherActivity()?.changePlantData(index,position,!isClick)
                        deadTimeAdapter.notifyDataSetChanged()
                    }
                }
                buyBikePlantLinearLayout.addView(view)
            }
        }


    }

    fun getFatherActivity(): BuyBikeConfigActivity? = activity as BuyBikeConfigActivity
}