package com.baojia.mebike.feature.exclusive.shopping.myorders

import android.annotation.SuppressLint
import android.content.Context
import android.view.MotionEvent
import android.view.View
import androidx.recyclerview.widget.LinearLayoutManager
import androidx.recyclerview.widget.RecyclerView
import com.baojia.mebike.R
import com.baojia.mebike.base.BaseCommonAdapter
import com.baojia.mebike.base.BaseViewHolder
import com.baojia.mebike.data.response.exclusive.shapping.ShoppingOrderResponse

class MyOrdersAdapter(val position :Int ,val context: Context?, list: ArrayList<ShoppingOrderResponse.DataBean>, layoutId: Int)
    : BaseCommonAdapter<ShoppingOrderResponse.DataBean>(context, list, layoutId) {

    @SuppressLint("ClickableViewAccessibility")
    override fun convert(holder: BaseViewHolder?, list: MutableList<ShoppingOrderResponse.DataBean>?, position: Int) {

        holder?.setVisbility(R.id.myOrdersItemImageRv,false)
        holder?.setVisbility(R.id.myOrdersItemImageLineIv,false)
        holder?.setVisbility(R.id.myOrdersItemPayTv,false)
        holder?.setVisbility(R.id.myOrdersItemCancleOrderTv,false)

        var bean = list?.get(position)
        bean ?: return

        if (bean.bikeImgs != null && bean.bikeImgs.isNotEmpty()){
            var photosAdapter = MyOrdersPhotosAdapter(context,bean.bikeImgs,R.layout.item_myorders_photo)
            holder?.setLayoutManager(R.id.myOrdersItemImageRv,LinearLayoutManager(context, RecyclerView.HORIZONTAL,false),photosAdapter)
            holder?.setVisbility(R.id.myOrdersItemImageRv,true)
            holder?.setVisbility(R.id.myOrdersItemImageLineIv,true)

        }else{
            holder?.setVisbility(R.id.myOrdersItemImageRv,false)
            holder?.setVisbility(R.id.myOrdersItemImageLineIv,false)
        }

        holder?.setText(R.id.myOrdersItemTimeTv,bean.createTime)
        holder?.setText(R.id.myOrdersItemMoneyTv,bean.amountStr)

        if (bean.packages.isEmpty()){
            holder?.setVisbility(R.id.myOrdersItemDescTv,false)
            holder?.setVisbility(R.id.myOrdersItemDescLineIv,false)

        }else{
            var desc = ""
            if (bean.packages.endsWith("\n")){
                desc = bean.packages.substring(0,bean.packages.length - 1)
            }else{
                desc = bean.packages
            }
            holder?.setText(R.id.myOrdersItemDescTv,desc)
            holder?.setVisbility(R.id.myOrdersItemDescTv,true)
            holder?.setVisbility(R.id.myOrdersItemDescLineIv,true)
        }


        //（ 0 待支付 1 已支付  ）
        if (bean.payStatus == 0){
            holder?.setVisbility(R.id.myOrdersItemPayTv,true)
            holder?.setVisbility(R.id.myOrdersItemCancleOrderTv,true)
            holder?.addOnClickListener(this,R.id.myOrdersItemPayTv,position)
            holder?.addOnClickListener(this,R.id.myOrdersItemCancleOrderTv,position)
        }

        var insideRv = holder?.findView<RecyclerView>(R.id.myOrdersItemImageRv)
        insideRv?.setOnTouchListener(object :View.OnTouchListener{
            override fun onTouch(v: View?, event: MotionEvent?): Boolean {
                if (event?.getAction() == MotionEvent.ACTION_UP) {
                    //模拟父控件的点击
                    holder?.getItemView()?.performClick();
                }
                return false
            }
        })

    }
}

//private TextView myOrdersItemTimeTv;
//private ImageView myOrdersItemTimeLineIv;
//private RecyclerView myOrdersItemImageRv;
//private ImageView myOrdersItemImageLineIv;
//private TextView myOrdersItemDescTv;
//private ImageView myOrdersItemDescLineIv;
//private TextView myOrdersItemMoneyTv;
//private TextView myOrdersItemPayTv;
//private TextView myOrdersItemCancleOrderTv;

