package com.baojia.mebike.feature.exclusive.shopping.myorders

import com.baojia.mebike.base.IBasePresenter
import com.baojia.mebike.data.response.exclusive.shapping.ShoppingOrderResponse
import com.baojia.mebike.data.response.order.PayByOtherResponse
import com.baojia.mebike.feature.model.IRefreshDataView

interface MyOrdersContract {
    interface View : IRefreshDataView<Presenter> {
        fun type() :Int
        fun setListData(it: List<ShoppingOrderResponse.DataBean>?, isRefresh :Boolean)


        /**
         * 支付成功回调
         * @param dataBean
         */
        fun orderPaySucceed(dataBean: PayByOtherResponse.DataBean)

        /**
         * 支付方式
         * @return
         */
        fun payMethod(): Int
        fun orderNo() :String?
        fun paySuccess()

        //是否为续期
        fun isRenewFee() :Boolean
        fun clearData()
    }

    interface Presenter : IBasePresenter {
        fun onLoadMore()
        fun onRefresh()

        /**
         * 支付
         */
        fun prePay()

        /**
         * 查询订单支付状态
         */
        fun checkOrderPayStatus()

        fun cancleOrder()

    }
}