package com.baojia.mebike.feature.exclusive.shopping.myorders

import android.app.Activity
import com.baojia.mebike.callback.HttpCallback
import com.baojia.mebike.data.response.BaseResponse
import com.baojia.mebike.data.response.exclusive.shapping.BuyOrderProgressResponse
import com.baojia.mebike.data.response.exclusive.shapping.ShoppingOrderDetailResponse
import com.baojia.mebike.data.response.exclusive.shapping.ShoppingOrderResponse
import com.baojia.mebike.data.response.main.PersonMainOrderResponse
import com.baojia.mebike.feature.model.PayModel
import com.baojia.mebike.feature.person_company.usebike.UseBikeModel
import com.baojia.mebike.http.HttpUtils
import com.baojia.mebike.util.JumpActivity
import com.baojia.mebike.util.Toast
import io.reactivex.disposables.Disposable
import java.util.*

class MyOrdersModel(activity: Activity) : UseBikeModel(activity) {

    /**
     * 产品列表接口  专享商城
     */
    private val LIST_ORDER = "/pmall/order/list/v3"
    /**
     * 产品列表接口  专享商城
     */
    private val ORDER_DETAIL = "/pmall/order/detail/v3"
    private val ORDER_CANCLE = "/pmall/order/cancel/v3"
    private val ORDER_CONFIRM_TAKE_CAR = "/pmall/bike/confirm/scan/v3"

    fun getListData(type: Int,currentPage: Int, httpCallback: HttpCallback<ShoppingOrderResponse?>?): Disposable {
        val params = HashMap<String, Any>()
        params["type"] = type
        params["pageNum"] = currentPage
        params["pageSize"] = 20
        return HttpUtils.postRequest(activity, LIST_ORDER, params, false, httpCallback, ShoppingOrderResponse::class.java)
    }



    fun getData(orderNo: String, httpCallback: HttpCallback<ShoppingOrderDetailResponse?>?): Disposable {
        val params = HashMap<String, Any>()
        params["orderNo"] = orderNo
        return HttpUtils.postRequest(activity, ORDER_DETAIL, params, true, httpCallback, ShoppingOrderDetailResponse::class.java)
    }

    fun cancleOrder(orderNo: String, httpCallback: HttpCallback<BaseResponse?>?): Disposable {
        val params = HashMap<String, Any>()
        params["orderNo"] = orderNo
        return HttpUtils.postRequest(activity, ORDER_CANCLE, params, true, httpCallback, BaseResponse::class.java)
    }

    fun confirmTakeCar(orderNo: String,plantNo: String?, httpCallback: HttpCallback<BuyOrderProgressResponse?>?): Disposable {
        val params = HashMap<String, Any?>()
        params["orderNo"] = orderNo
        params["plantNo"] = plantNo
        return HttpUtils.postRequest(activity, ORDER_CONFIRM_TAKE_CAR, params, true, httpCallback, BuyOrderProgressResponse::class.java)
    }


}