package com.baojia.mebike.feature.exclusive.shopping.myorders

import android.app.Activity
import android.content.Intent
import androidx.recyclerview.widget.LinearLayoutManager
import com.baojia.mebike.R
import com.baojia.mebike.alipay.AliPayManager
import com.baojia.mebike.base.BaseCommonAdapter
import com.baojia.mebike.base.BaseRefreshActivity
import com.baojia.mebike.callback.IDialogCallback
import com.baojia.mebike.callback.PayListener
import com.baojia.mebike.config.Config
import com.baojia.mebike.data.response.exclusive.shapping.ShoppingOrderResponse
import com.baojia.mebike.data.response.order.PayByOtherResponse
import com.baojia.mebike.dialog.LeftRightButtonTipsDialog
import com.baojia.mebike.feature.exclusive.shopping.orderdetails.ShoppingOrderDetailsActivity
import com.baojia.mebike.feature.exclusive.shopping.paysuccess.PaySuccessActivity
import com.baojia.mebike.feature.infinitecard.dialog.BuyInfiniteCardDialog
import com.baojia.mebike.util.CollectionsWrapper
import com.baojia.mebike.util.Toast
import com.baojia.mebike.util.ToolBox
import com.baojia.mebike.util.WechatPayUtils
import kotlinx.android.synthetic.main.layout_recyclerview_only.*

//4.9.0我的订单页面
open class MyOrdersNewActivity : BaseRefreshActivity<MyOrdersContract.Presenter, MyOrdersContract.View>(), MyOrdersContract.View, PayListener {


    companion object {
        fun start(activity: Activity) {
            var intent = Intent(activity, MyOrdersNewActivity::class.java)
            activity.startActivity(intent)
        }

        //是否取消订单
        open var isCancle = false

    }

    override fun setCenterTitle(): String = "我的订单"

    override fun isVisibleTitleBar(): Boolean = true

    var position = 0
    var myOrdersAdapter: MyOrdersAdapter? = null;
    var mPresenter: MyOrdersContract.Presenter? = null
    private val mDatas = arrayListOf<ShoppingOrderResponse.DataBean>()
    var payDialog: BuyInfiniteCardDialog? = null

    var orderNo: String? = null
    var payMethod = Config.CODE_PAYCHANNLID_WECHAT
    //是否进入重新刷新页面
    var reload = true
    var isRenew = false
//    var needCheckOrder = false


    //订单类型（默认传0 待付款） 0：待付款 1：待发货 2：待收货 3：已收货 4：退款/到期
    override fun type(): Int = position

    override fun isRenewFee(): Boolean = isRenew


    override fun initAdapter() {
        mPresenter = MyOrdersPresenter(this, this)
        recyclerview.setBackgroundResource(R.color.background_color)

        myOrdersAdapter = MyOrdersAdapter(position, this, mDatas, R.layout.item_myorders_shopping)
        recyclerview.adapter = myOrdersAdapter
        recyclerview.layoutManager = LinearLayoutManager(this)
        myOrdersAdapter?.setOnItemChildViewClickListner { view, position ->
            run {
                orderNo = mDatas[position].orderNo
//                this.isRenew = mDatas[position].goodsType == 4 || mDatas[position].goodsType == 5
                when (view.id) {
                    R.id.myOrdersItemPayTv -> {
                        // 购买
                        payDialog = BuyInfiniteCardDialog.showDialog(supportFragmentManager, 1, mDatas[position].amountStr) { _, payMethod ->
                            // 支付
                            payDialog?.dismiss()
                            this.payMethod = payMethod
                            mPresenter?.prePay()
//                            needCheckOrder = true
                        }
                    }
                    R.id.myOrdersItemCancleOrderTv -> {
                        val dialog = LeftRightButtonTipsDialog.show(supportFragmentManager, null, "确认取消订单吗？", 2, R.mipmap.yellow_tips_icon)
                        dialog.setDialogCallback(object : IDialogCallback() {
                            override fun onConfirm() {
                                super.onConfirm()
                                mPresenter?.cancleOrder()
                            }
                        })
                    }
                }
            }
        }

        myOrdersAdapter?.setOnItemClickListner { _, position ->
            run {
                orderNo = null
                ShoppingOrderDetailsActivity.start(this@MyOrdersNewActivity, mDatas[position].orderNo)
            }
        }

        refreshLayout.autoRefresh()

    }

    override fun onResume() {
        super.onResume()
        if (isCancle) {
            mPresenter?.onRefresh()
            isCancle = false
        }else{
            mPresenter?.checkOrderPayStatus()
        }
    }

    override fun onRefresh() {
        mPresenter?.onRefresh()
    }

    override fun getAdapter(): BaseCommonAdapter<Any?> = myOrdersAdapter as BaseCommonAdapter<Any?>

    override fun onLoadMore() {
        mPresenter?.onLoadMore()
    }

    override fun setPresenter(presenter: MyOrdersContract.Presenter?) {
    }

    override fun setListData(it: List<ShoppingOrderResponse.DataBean>?, isRefresh: Boolean) {
        if (isRefresh) {
            if (CollectionsWrapper.isEmpty(it)) {
                mDatas.clear()
                myOrdersAdapter?.notifyDataSetChanged()
                return
            }
            mDatas.clear()
            mDatas.addAll(it!!)
            myOrdersAdapter?.notifyDataSetChanged()
        } else {
            if (CollectionsWrapper.isEmpty(it)) {
                return
            }
            mDatas.addAll(it!!)
            myOrdersAdapter?.notifyDataSetChanged()
        }
    }


    override fun orderPaySucceed(dataBean: PayByOtherResponse.DataBean) {
        if (dataBean.payChannelId == 1) {
            WechatPayUtils.wechatPay(this, dataBean.appid, dataBean.partnerid, dataBean.prepayid,
                    dataBean.wxpackage, dataBean.noncestr, dataBean.timestamp,
                    dataBean.sign)

        } else if (dataBean.payChannelId == 2) {
            AliPayManager(this)
                    .alipayV2(this, dataBean.orderInfo)
        }
    }

    override fun payMethod(): Int = payMethod

    override fun orderNo(): String? = orderNo

    override fun paySuccess() {
        //查单成功
        PaySuccessActivity.startActivity(this,orderNo!!)
    }

    override fun onSuccess() {
    }

    override fun onFailed(msg: String?) {
        Toast.show(this, msg)
    }


    override fun clearData() {
        mDatas.clear()
        myOrdersAdapter?.notifyDataSetChanged()
    }

}