package com.baojia.mebike.feature.exclusive.shopping.myorders

import android.app.Activity
import com.amap.api.mapcore.util.it
import com.baojia.mebike.base.BasePresenter
import com.baojia.mebike.callback.HttpCallback
import com.baojia.mebike.data.response.BaseResponse
import com.baojia.mebike.data.response.exclusive.shapping.ShoppingOrderResponse
import com.baojia.mebike.data.response.order.PayByOtherResponse
import com.baojia.mebike.util.CollectionsWrapper
import com.baojia.mebike.util.Toast

class MyOrdersPresenter(activity: Activity,val mView :MyOrdersContract.View) :BasePresenter(activity) ,MyOrdersContract.Presenter {

    override fun onLoadMore() {
        getList(currentPage,false)
    }

    override fun onRefresh() {
        getList(currentPage,true)
    }


    var currentPage = 1

    var mModel = MyOrdersModel(activity)

    fun getList(page: Int, isRefash: Boolean) {
        if (isRefash) {
            currentPage = 1
        } else {
            currentPage += 1
        }
        addDisposable(mModel.getListData(mView.type(),currentPage, object : HttpCallback<ShoppingOrderResponse?>() {
            override fun onSucceed(data: ShoppingOrderResponse?) {
                super.onSucceed(data)
                mView.hideAllPage()
                if (isRefash) mView.refreshDataSucceed() else mView.loadMoreDataSucceed()
                data?.let {
                    mView.setListData(it.data,isRefash)

                    if (CollectionsWrapper.isEmpty(it.data)) {
                        mView.showNoDataPage()
                        return
                    }

                }
            }

            override fun onFailed(code: Int, message: String?) {
                super.onFailed(code, message)
                if (isRefash) mView.refreshDataFailed(message) else mView.loadMoreDataFailed(message)
            }

            override fun onError(code: Int, message: String?) {
                super.onError(code, message)
                if (isRefash) mView.refreshDataFailed(message) else mView.loadMoreDataFailed(message)
                mView.showErrorPage()

            }
        }))
    }

    override fun prePay() {
        addDisposable(mModel.prePay( mView.payMethod(),16, mView.orderNo(),object : HttpCallback<PayByOtherResponse.DataBean>() {
            override fun onSucceed(data: PayByOtherResponse.DataBean) {
                super.onSucceed(data)
                mView.orderPaySucceed(data)
            }
        }))
    }

    override fun checkOrderPayStatus() {
        mView.orderNo()?:return
        mView.orderNo().let {
            mModel.checkOrderPayStatus(it, if (mView.isRenewFee()) 20 else 5, object : HttpCallback<BaseResponse?>() {
                override fun onSucceed(data: BaseResponse?) {
                    super.onSucceed(data)
                    data?.let {
                        mView.paySuccess()
                    }
                }

                override fun onFailed(code: Int, message: String?) {
                    super.onFailed(code, message)
                    Toast.show(context,message)
                }

                override fun onError(code: Int, message: String?) {
                    super.onError(code, message)
                    onFailed(-1,message)
                }
            })
        }
    }

    override fun cancleOrder() {
        mView.orderNo() ?:return
        mModel.cancleOrder(mView.orderNo()!!,object :HttpCallback<BaseResponse?>(){
            override fun onSucceed(data: BaseResponse?) {
                super.onSucceed(data)
                //订单取消成功
                onRefresh()
            }

            override fun onFailed(code: Int, message: String?) {
                super.onFailed(code, message)
            }

            override fun onError(code: Int, message: String?) {
                super.onError(code, message)
                onFailed(-1,message)
            }
        })

    }


}