package com.baojia.mebike.feature.exclusive.shopping.near_shop

import android.app.Activity
import com.baojia.mebike.base.BaseModel
import com.baojia.mebike.callback.HttpCallback
import com.baojia.mebike.data.CommData
import com.baojia.mebike.data.response.exclusive.NearShopResponse
import com.baojia.mebike.http.HttpUtils
import com.baojia.mebike.util.Toast
import io.reactivex.disposables.Disposable

/**
 * +----------------------------------------------------------------------
 * | @time 2018/12/22:6:51 PM
 * | @author house
 * | @class_describe
 * +----------------------------------------------------------------------
 **/
class NearShopModel constructor(mContext: Activity) : BaseModel(mContext) {

    private val POWER_STATION_URL = "/pmall/get/near/store"

    fun searchNearShop( httpCallback: HttpCallback<ArrayList<NearShopResponse.DataBean.StoresBean>?>): Disposable {
        var params = mutableMapOf<String, Any?>()
        params["latitude"] = CommData.locationConfig.latLng.latitude
        params["longitude"] = CommData.locationConfig.latLng.longitude
        return HttpUtils.postRequest(activity, POWER_STATION_URL, params, object : HttpCallback<NearShopResponse>() {
            override fun onSucceed(data: NearShopResponse?) {
                super.onSucceed(data)

                data?.data?.let {
                    if (it.stores != null) {
                        httpCallback.onSucceed(it.stores)
                    }
                }

            }

            override fun onFailed(code: Int, message: String?) {
                super.onFailed(code, message)
                Toast.show(activity, message)
            }

            override fun onError(code: Int, message: String?) {
                super.onError(code, message)
                onFailed(code, message)
            }
        }, NearShopResponse::class.java)
    }
}