package com.baojia.mebike.feature.exclusive.shopping.orderdetails

import android.content.Context
import android.content.Intent
import android.os.Bundle
import android.view.View
import androidx.recyclerview.widget.LinearLayoutManager
import com.amap.api.mapcore.util.it
import com.baojia.mebike.R
import com.baojia.mebike.alipay.AliPayManager
import com.baojia.mebike.base.BaseActivity
import com.baojia.mebike.callback.IDialogCallback
import com.baojia.mebike.callback.PayListener
import com.baojia.mebike.config.Config
import com.baojia.mebike.data.response.exclusive.shapping.ShoppingOrderDetailResponse
import com.baojia.mebike.data.response.order.PayByOtherResponse
import com.baojia.mebike.dialog.LeftRightButtonTipsDialog
import com.baojia.mebike.feature.exclusive.shopping.nearBike.NearBikeActivity
import com.baojia.mebike.feature.exclusive.shopping.near_shop.NearShopActivity
import com.baojia.mebike.feature.exclusive.shopping.sendprogress.SendProgressActivity
import com.baojia.mebike.feature.infinitecard.dialog.BuyInfiniteCardDialog
import com.baojia.mebike.util.JumpActivity
import com.baojia.mebike.util.Toast
import com.baojia.mebike.util.WechatPayUtils
import kotlinx.android.synthetic.main.activity_order_detail_shopping.*
import kotlinx.android.synthetic.main.include_bottom_common.*

class ShoppingOrderDetailsActivity : BaseActivity(), ShoppingOrderDetailsContract.View, PayListener {


    companion object {
        @JvmStatic
        fun start(activity: Context, orderNo: String, plateNo: String? = "") {
            var intent = Intent(activity, ShoppingOrderDetailsActivity::class.java)
            intent.putExtra("orderNo", orderNo)
            intent.putExtra("plateNo", plateNo)
            activity.startActivity(intent)
        }
    }

    var orderStatus = -1
    //支付状态（ 0 待支付 1 已支付  ）
    var payStatus = -1
    //（0：确认收车 1：扫码收车）
    var scanOr = -1
    var bikeOrBettery = -1
    var takeType = -1
    //（ 1 购买 2 续费  ）
    var packageType = -1
    var payMethod = Config.CODE_PAYCHANNLID_WECHAT
    var mPresenter: ShoppingOrderDetailsContract.Presenter? = null
    var orderNo = ""
    //实物订单相关的orderno
    var orderNo_solid = ""
    var plateNo: String? = null
    val solidOrderData = arrayListOf<ShoppingOrderDetailResponse.DataBean.BikesBean.ProMsgsBean>()
    val verticalOrderData = arrayListOf<ShoppingOrderDetailResponse.DataBean.OrdersBean>()
    val otherOrderData = arrayListOf<ShoppingOrderDetailResponse.DataBean.OrdersBean>()
    var solidOrderAdapter: ShoppingOrderDetailProductAdapter? = null
    var verticalOrderAdapter: ShoppingOrderDetailAdapter? = null
    var otherOrderAdapter: ShoppingOrderDetailAdapter? = null
    var payDialog: BuyInfiniteCardDialog? = null
    var amount: String? = null
    var protectId: Long? = 0
    var colorId: Int? = 0

    override fun setPresenter(presenter: ShoppingOrderDetailsContract.Presenter?) {
    }

    override fun isVisibleTitleBar(): Boolean = true

    override fun setTitle(): String = "订单详情"

    override fun layoutId(): Int = R.layout.activity_order_detail_shopping

    override fun bindView(savedInstanceState: Bundle?) {
        intent?.let {
            orderNo = it.getStringExtra("orderNo")
            plateNo = it.getStringExtra("plateNo")
        }

        mPresenter = ShoppingOrderDetailsPresenter(this, this)


        solidOrderAdapter = ShoppingOrderDetailProductAdapter(this, solidOrderData, R.layout.layout_item_bike_info_orderdetail)
        verticalOrderAdapter = ShoppingOrderDetailAdapter(this, verticalOrderData, R.layout.item_order_detail_shopping)
        otherOrderAdapter = ShoppingOrderDetailAdapter(this, otherOrderData, R.layout.item_order_detail_shopping)
        solidDescRv.layoutManager = LinearLayoutManager(this)
        solidDescRv.adapter = solidOrderAdapter
        virtualDescRv.layoutManager = LinearLayoutManager(this)
        virtualDescRv.adapter = verticalOrderAdapter
        otherDescRv.layoutManager = LinearLayoutManager(this)
        otherDescRv.adapter = otherOrderAdapter

        mPresenter?.getDetailData()


        setViewClickDuration(bottomViewOkOnlyTv, 1)
        setViewClickDuration(bottomViewOkLeftTv, 1)
        setViewClickDuration(bottomViewOkRightTv, 1)
        setViewClickDuration(bottomViewOkOnlyCstyleTv, 1)
        setViewClickDuration(solidStutasTypeTv, 1)
    }

    override fun onNewIntent(intent: Intent?) {
        super.onNewIntent(intent)
        intent?.let {
            orderNo = it.getStringExtra("orderNo")
            plateNo = it.getStringExtra("plateNo")
        }
    }

    override fun onResume() {
        super.onResume()
        if (payStatus == 0) {
            mPresenter?.checkOrderPayStatus()
        }
    }


    override fun orderNo(): String = orderNo
    override fun isRenewFee(): Boolean = packageType == 2

    override fun setData(data: ShoppingOrderDetailResponse.DataBean) {

        this.payStatus = data.payStatus
        this.amount = "${data.amount}"
        this.packageType = data.packageType

        data.bikes?.let {
            orderDetailSolidConsl.visibility = View.VISIBLE
            if (it.proMsgs.isEmpty()){
                orderDetailSolidConsl.visibility = View.GONE
                return@let
            }
            this.orderNo_solid = it.orderNo
            this.orderStatus = it.orderStatus
            this.takeType = it.takeType
            this.bikeOrBettery = it.bikeOrBettery
            this.scanOr = it.scanOr
            if (it.proMsgs != null && it.proMsgs.isNotEmpty()){
                this.protectId = it.proMsgs[0]?.prodId
                this.colorId = it.proMsgs[0]?.prodColorId
            }

            solidStutasTypeTv.text = it.orderStatusStr
            if (it.takeType == 1) {
                takeTypeDescTv.visibility = View.VISIBLE
                takeTypeDescTv.text = "${it.takeUserName}  ${it.takeUserPhone}  \n${it.takeaddr}"
            }

            it.proMsgs?.run {
                solidOrderData.clear()
                solidOrderData.addAll(this)
                return@run solidOrderAdapter?.notifyDataSetChanged()
            }
            return@let
        }



        data.packages?.let {
            if (it.isNotEmpty()) {
                virtualIconIv.visibility = View.VISIBLE
                virtualOrderTitleTv.visibility = View.VISIBLE
                verticalOrderData.clear()
                verticalOrderData.addAll(it)
                verticalOrderAdapter?.notifyDataSetChanged()
            }
            return@let
        }

        data.orders?.let {
            if (it.isNotEmpty()) {
                otherOrderData.clear()
                otherOrderData.addAll(it)
                otherOrderAdapter?.notifyDataSetChanged()
            }
        }

        orderDetailMoneyTv.text = data.amountStr

        if (data.payStatus == 1) {

            when (orderStatus) {
                //（-1：已取消 0 待支付 1 已支付 2 待配送 3 配送中 4 预约中 5 已收车 6 已过期 7 已回收 8 已退款  ）
                //待支付 。 车辆已被接受
                0 -> {
                    bottomLayout.visibility = View.VISIBLE
                    bottomViewOkLeftTv.text = "取消"
                    bottomViewOkRightTv.text = "立即支付"

                }
                //已支付   支付成功   等待系统接单
                1 -> {
                    if (this.bikeOrBettery == 1) {
                        bottomLayout.visibility = View.VISIBLE
                        bottomViewOkLeftTv.visibility = View.GONE
                        bottomViewOkRightTv.visibility = View.GONE
                        bottomViewOkOnlyCstyleTv.visibility = View.VISIBLE
                        when (this.takeType) {
                            2 -> {
                                bottomViewOkOnlyCstyleTv.text = "查看附近车辆"
                            }
                            3 -> {
                                bottomViewOkOnlyCstyleTv.text = "查看附近门店"

                            }
                            else -> {
                                bottomLayout.visibility = View.GONE
                            }

                        }

                    }
                }
                //待发货   统一发货
                2, 4 -> {
                    if (this.bikeOrBettery == 1) {
                        bottomLayout.visibility = View.VISIBLE
                        bottomViewOkRightTv.text = "扫码取车"
                        when (this.takeType) {
                            2 -> {
                                bottomViewOkLeftTv.text = "查看附近车辆"
                            }
                            3 -> {
                                bottomViewOkLeftTv.text = "查看附近门店"

                            }
                            else -> {
                                bottomLayout.visibility = View.GONE
                            }

                        }
                    }
                }
                //代收车  安排配送
                3 -> {
                    if (this.bikeOrBettery == 1) {
                        bottomLayout.visibility = View.VISIBLE
                        bottomViewOkLeftTv.visibility = View.GONE
                        bottomViewOkRightTv.visibility = View.GONE
                        bottomViewOkOnlyTv.text = "扫码确认收车"
                        bottomViewOkOnlyTv.visibility = View.VISIBLE
                    }


                }
                //已收车    车辆已被接受
                5 -> {

                }
                //已过期    车辆已过期待收回
                6 -> {

                }
                //已收回    确认收回
                7 -> {

                }
                //已退款     订单退款
                8 -> {

                }
            }
        } else {
            //未支付
            bottomLayout.visibility = View.VISIBLE
            bottomViewOkLeftTv.text = "取消"
            bottomViewOkRightTv.text = "立即支付"
        }


    }


    override fun setViewClick(view: View?) {
        super.setViewClick(view)
        when (view) {
            bottomViewOkOnlyTv -> {

                if (bottomViewOkOnlyTv.text.toString() == "扫码确认收车") {
                    //是否包含物联网模块
                    if (scanOr == 1) {
                        var bundle = Bundle()
                        bundle.putString("orderNo", orderNo_solid)
                        bundle.putInt("orderStatus", orderStatus)
                        JumpActivity.JumpScanActivity(this, 4, bundle)
                        return
                    }
                    val dialog = LeftRightButtonTipsDialog.show(supportFragmentManager, null, "确认已经收到车辆吗？", 2, R.mipmap.yellow_tips_icon)
                    dialog.setDialogCallback(object : IDialogCallback() {
                        override fun onConfirm() {
                            super.onConfirm()
                            mPresenter?.confirmTakeCar()
                        }
                    })

                }
            }
            bottomViewOkOnlyCstyleTv -> {
                when (bottomViewOkOnlyCstyleTv.text.toString()) {
                    "查看附近车辆" -> {
                        var bundle = Bundle()
                        bundle.putString("orderNo", orderNo_solid)
                        bundle.putInt("orderStatus", orderStatus)
                        NearBikeActivity.start(this, orderNo_solid, bundle, 1, protectId, colorId)
                    }
                    "查看附近门店" -> {
                        NearShopActivity.start(this)
                    }

                }
            }

            bottomViewOkLeftTv -> {
                if (bottomViewOkLeftTv.text.toString() == "取消") {
                    val dialog = LeftRightButtonTipsDialog.show(supportFragmentManager, null, "确认取消订单吗？", 2, R.mipmap.yellow_tips_icon)
                    dialog.setDialogCallback(object : IDialogCallback() {
                        override fun onConfirm() {
                            super.onConfirm()
                            mPresenter?.cancleOrder()
                        }
                    })
                }
                if (bottomViewOkLeftTv.text.toString() == "查看附近车辆") {
                    var bundle = Bundle()
                    bundle.putString("orderNo", orderNo_solid)
                    bundle.putInt("orderStatus", orderStatus)
                    NearBikeActivity.start(this, orderNo_solid, bundle, 1, protectId, colorId)
                }
                if (bottomViewOkLeftTv.text.toString() == "查看附近门店") {
                    NearShopActivity.start(this)
                }

            }
            bottomViewOkRightTv -> {
                if (bottomViewOkRightTv.text.toString() == "立即支付") {
                    payDialog = BuyInfiniteCardDialog.showDialog(supportFragmentManager, 1, amount) { _, payMethod ->
                        // 支付
                        payDialog?.dismiss()
                        this.payMethod = payMethod
                        mPresenter?.payRequest()
                    }
                }
                if (bottomViewOkRightTv.text.toString() == "扫码取车") {
                    var bundle = Bundle()
                    bundle.putString("orderNo", orderNo_solid)
                    bundle.putInt("orderStatus", orderStatus)
                    JumpActivity.JumpScanActivity(this, 4, bundle)
                }
            }

            solidStutasTypeTv -> {
                SendProgressActivity.start(this, 0, orderNo_solid, null)
            }

        }
    }

    override fun channelMethod(): Int = payMethod

    override fun wechatPay(dataBean: PayByOtherResponse.DataBean) {
        WechatPayUtils.wechatPay(this, dataBean.appid, dataBean.partnerid, dataBean.prepayid,
                dataBean.wxpackage, dataBean.noncestr, dataBean.timestamp,
                dataBean.sign)
    }

    override fun aliPay(dataBean: PayByOtherResponse.DataBean) {
        AliPayManager(this)
                .alipayV2(this, dataBean.orderInfo)
    }

    override fun onSuccess() {
    }

    override fun onFailed(msg: String?) {
        Toast.show(this, msg)
    }

    override fun plantNo(): String? = plateNo


}