package com.baojia.mebike.feature.exclusive.shopping.orderdetails

import android.app.Activity
import android.text.TextUtils
import com.amap.api.mapcore.util.it
import com.baojia.mebike.base.BasePresenter
import com.baojia.mebike.callback.HttpCallback
import com.baojia.mebike.data.response.BaseResponse
import com.baojia.mebike.data.response.exclusive.shapping.BuyOrderProgressResponse
import com.baojia.mebike.data.response.exclusive.shapping.ShoppingOrderDetailResponse
import com.baojia.mebike.data.response.main.PersonMainOrderResponse
import com.baojia.mebike.data.response.order.PayByOtherResponse
import com.baojia.mebike.feature.exclusive.shopping.myorders.MyOrdersModel
import com.baojia.mebike.feature.exclusive.shopping.myorders.MyOrdersNewActivity
import com.baojia.mebike.feature.exclusive.shopping.paysuccess.PaySuccessActivity
import com.baojia.mebike.util.JumpActivity
import com.baojia.mebike.util.Toast

class ShoppingOrderDetailsPresenter(var activity: Activity,val view :ShoppingOrderDetailsContract.View) :BasePresenter(activity),ShoppingOrderDetailsContract.Presenter {

    var model = MyOrdersModel(activity)

    override fun payRequest() {
        addDisposable(model.prePay( view.channelMethod(),16, view.orderNo(),object : HttpCallback<PayByOtherResponse.DataBean>() {
            override fun onSucceed(data: PayByOtherResponse.DataBean) {
                super.onSucceed(data)
                data?:return
                if (data.payChannelId == 1) {
                   view.wechatPay(data)

                } else if (data.payChannelId == 2) {
                    view.aliPay(data)
                }
            }
        }))
    }


    override fun getDetailData() {
        model.getData(view.orderNo(),object :HttpCallback<ShoppingOrderDetailResponse?>(){
            override fun onSucceed(data: ShoppingOrderDetailResponse?) {
                super.onSucceed(data)
                data?.data?.let {
                    view.setData(it)
                }
            }

            override fun onFailed(code: Int, message: String?) {
                super.onFailed(code, message)
            }

            override fun onError(code: Int, message: String?) {
                super.onError(code, message)
                onFailed(-1,message)
            }
        })

    }
    override fun cancleOrder() {
        model.cancleOrder(view.orderNo(),object :HttpCallback<BaseResponse?>(){
            override fun onSucceed(data: BaseResponse?) {
                super.onSucceed(data)
                MyOrdersNewActivity.isCancle = true
                activity.finish()
            }

            override fun onFailed(code: Int, message: String?) {
                super.onFailed(code, message)
            }

            override fun onError(code: Int, message: String?) {
                super.onError(code, message)
                onFailed(-1,message)
            }
        })

    }
   override fun confirmTakeCar() {
        model.confirmTakeCar(view.orderNo(),view.plantNo(),object :HttpCallback<BuyOrderProgressResponse?>(){
            override fun onSucceed(data: BuyOrderProgressResponse?) {
                super.onSucceed(data)
                data?.data?:return
                if (data?.data.orderPage == 0) {
                    JumpActivity.JumpToMainActivity(activity)
                    return
                }
                // 个人专属车辆
                // 直接跳转用车页面
                JumpActivity.JumpCompanyPersonalUseBikeActivity(activity,0,view.orderNo())
            }

            override fun onFailed(code: Int, message: String?) {
                super.onFailed(code, message)
            }

            override fun onError(code: Int, message: String?) {
                super.onError(code, message)
                onFailed(-1,message)
            }
        })

    }


    override fun checkOrderPayStatus() {
        if (TextUtils.isEmpty(view.orderNo()))return
        view.orderNo().let {
            model.checkOrderPayStatus(it, if (view.isRenewFee()) 20 else 5, object : HttpCallback<BaseResponse?>() {
                override fun onSucceed(data: BaseResponse?) {
                    super.onSucceed(data)
                    data?.run{
                        PaySuccessActivity.startActivity(activity, it,view.plantNo())
                    }
                }

                override fun onFailed(code: Int, message: String?) {
                    super.onFailed(code, message)
                    Toast.show(context,message)
                }

                override fun onError(code: Int, message: String?) {
                    super.onError(code, message)
                    onFailed(-1,message)
                }
            })
        }
    }

}