package com.baojia.mebike.feature.exclusive.shopping.aboutexclusive

import android.app.Activity
import com.baojia.mebike.base.BasePresenter
import com.baojia.mebike.callback.HttpCallback
import com.baojia.mebike.data.response.exclusive.shapping.BuyOrderProgressResponse
import com.baojia.mebike.data.response.main.PersonMainOrderResponse
import com.baojia.mebike.data.response.shopping.ListProcessBean
import com.baojia.mebike.feature.exclusive.shopping.orderprogress.BuyOrderProgressModel
import com.baojia.mebike.util.JumpActivity
import com.baojia.mebike.util.Toast
import com.umeng.commonsdk.stateless.UMSLEnvelopeBuild.mContext

/**
 * @name mebikeRewrite
 * @classPackage com.baojia.mebike.feature.exclusive.shopping.aboutexclusive
 * @author lycc1
 * @time 2018/12/24 21:10
 * @class describe
 * @class 中文描述
 */
class BuyOrderProgressPresenter(val mContext: Activity?, val mView: BuyOrderProgressContract.View) : BasePresenter(mContext), BuyOrderProgressContract.Presenter {

    var mModel: BuyOrderProgressModel? = null

    init {
        mView.setPresenter(this)
        mModel = BuyOrderProgressModel(mContext!!)
    }

    /**
     * 点击确认收车
     */
    override fun sureReceiveBike(orderNo: String?, plateNo: String?, goodsType: Int) {
        addDisposable(mModel?.sureReceiveBike(orderNo!!, plateNo, object : HttpCallback<BuyOrderProgressResponse>() {
            override fun onSucceed(data: BuyOrderProgressResponse) {
                super.onSucceed(data)
                data?.data ?: return
                if (data?.data.orderPage == 0) {
                    JumpActivity.JumpToMainActivity(mContext)
                    return
                }
                // 个人专属车辆
                // 直接跳转用车页面
//                                    data.plateNo, 1, data.returnMsg,data.extensionMileage)
                JumpActivity.JumpCompanyPersonalUseBikeActivity(context, 0, orderNo)

            }

            override fun onFailed(code: Int, message: String?) {
                super.onFailed(code, message)
                Toast.show(mContext, message)
            }

            override fun onError(code: Int, message: String?) {
                super.onError(code, message)
                onFailed(code, message)
            }
        }))
    }

    override fun getListProcess(orderNo: String?) {
        addDisposable(mModel?.getListProcess(orderNo!!, object : HttpCallback<ListProcessBean?>() {
            override fun onSucceed(data: ListProcessBean?) {
                super.onSucceed(data)
                mView.setListData(data)
            }

            override fun onFailed(code: Int, message: String?) {
                super.onFailed(code, message)
                Toast.show(mContext, message)
            }

            override fun onError(code: Int, message: String?) {
                super.onError(code, message)
                onFailed(code, message)
            }
        }))
    }

}