package com.baojia.mebike.feature.exclusive.shopping.renewalfee

import android.content.Context
import android.content.Intent
import android.os.Bundle
import android.view.View
import android.widget.ImageView
import android.widget.TextView
import androidx.recyclerview.widget.GridLayoutManager
import androidx.recyclerview.widget.LinearLayoutManager
import androidx.recyclerview.widget.RecyclerView
import com.baojia.mebike.R
import com.baojia.mebike.alipay.AliPayManager
import com.baojia.mebike.base.BaseActivity
import com.baojia.mebike.callback.IDialogCallback
import com.baojia.mebike.callback.PayListener
import com.baojia.mebike.config.Config
import com.baojia.mebike.data.response.exclusive.shapping.BuyBikeConfigResponse
import com.baojia.mebike.data.response.order.PayByOtherResponse
import com.baojia.mebike.data.response.shopping.OrderConfirmBean
import com.baojia.mebike.data.response.shopping.OrderConfirmItemBean
import com.baojia.mebike.dialog.CommonTipsDialog
import com.baojia.mebike.feature.exclusive.shopping.aboutexclusive.RenewalFeeContract
import com.baojia.mebike.feature.exclusive.shopping.aboutexclusive.RenewalFeePresenter
import com.baojia.mebike.feature.exclusive.shopping.buybikeconfig.BuyBikePlantAdapter
import com.baojia.mebike.feature.exclusive.shopping.buybikeconfig.OrderConfirmInfoDialog
import com.baojia.mebike.feature.infinitecard.dialog.BuyInfiniteCardDialog
import com.baojia.mebike.imageloader.ImageLoader
import com.baojia.mebike.util.JumpActivity
import com.baojia.mebike.util.Toast
import com.baojia.mebike.util.WechatPayUtils
import kotlinx.android.synthetic.main.activity_renewal_fee.*
import kotlinx.android.synthetic.main.layout_buy_bike_bottom_money.*
import java.text.DecimalFormat

//电池或车辆  或套餐续期
class RenewalFeeAct : BaseActivity(), RenewalFeeContract.View, PayListener {

    //state  0 车辆续期   1 电池续期  2换电无忧套餐续期  4 售后无忧
    companion object {
        @JvmStatic
        fun start(activity: Context, state: Int? = 0, bikeId: Int? = 0, pmallOrderId: Int? = 0, virGroupId: Int? = 0) {
            var intent = Intent(activity, RenewalFeeAct::class.java)
            intent.putExtra("state", state)
            intent.putExtra("bikeId", bikeId)
            intent.putExtra("pmallOrderId", pmallOrderId)
            intent.putExtra("virGroupId", virGroupId)
            activity.startActivity(intent)

        }
    }

    override fun layoutId(): Int = R.layout.activity_renewal_fee

    override fun isVisibleTitleBar(): Boolean = true

    //0 车辆续期   1 电池续期  2换电无忧 4 售后无忧套餐续期(也不知道后台把3丢哪了)
    var state = 0
    var payMethod = Config.CODE_PAYCHANNLID_WECHAT
    var presenter: RenewalFeePresenter? = null
    var payDialog: BuyInfiniteCardDialog? = null
    var batteryDeposite: Double = 0.00
    private var packageData: ArrayList<BuyBikeConfigResponse.DataBean.PackagesBean>? = arrayListOf()
    private var titleData = arrayListOf<BuyBikeConfigResponse.DataBean.BikePricesBean>()
    var bikeId = 0
    var pmallOrderId = 0
    var virGroupId = 0
    //本地缓存数据
    var dialogData: OrderConfirmBean = OrderConfirmBean("", "", "", 0.00, arrayListOf())
    private var titleAdapter: RenewTitleAdapter? = null
    var allPrice = 0.00
    //上一次价钱   动画需要
    var oldPrice = 0.00
    private val fnum = DecimalFormat("##0.00")

    var dataBean: BuyBikeConfigResponse.DataBean? = null

    override fun bindView(savedInstanceState: Bundle?) {
        intent?.let {
            state = it.getIntExtra("state", 0)
            bikeId = it.getIntExtra("bikeId", 0)
            pmallOrderId = it.getIntExtra("pmallOrderId", 0)
            virGroupId = it.getIntExtra("virGroupId", 0)
        }
        presenter = RenewalFeePresenter(this, this)


        renewalProductInfoRv.layoutManager = LinearLayoutManager(this)
        titleAdapter = RenewTitleAdapter(this,titleData,R.layout.item_buy_bike_info)
        renewalProductInfoRv.adapter = titleAdapter

        buyBikeBottomViewOkTv.text = "购买"
        buyBikeBottomViewMoneyChangeTv.visibility = View.VISIBLE
        buyBikeBottomViewMoneyTv.visibility = View.INVISIBLE
        setViewClickDuration(buyBikeBottomViewOkTv, 1)
        setViewClickDuration(bottomLayout, 1)

        when (state) {
            0 -> {
                setTitle("车辆续期")
                renewalProductInfoRv.visibility = View.VISIBLE
                presenter?.getData()
            }
            1 -> {
                setTitle("电池续期")
                renewalProductInfoRv.visibility = View.VISIBLE
                presenter?.getData()
            }
            2 -> {
                setTitle("换电无忧")
                renewalImageView.visibility = View.VISIBLE
                presenter?.getDataTwo()

            }
            4 -> {
                setTitle("售后无忧")
                renewalImageView.visibility = View.VISIBLE
                presenter?.getDataTwo()
            }


        }


    }

    override fun setViewClick(view: View?) {
        super.setViewClick(view)
        if (buyBikeBottomViewOkTv == view) {
            var isReturn = false
            packageData?.let {
                for (index in it.indices) {
                    if (it[index].required == 1) {
                        var isClicked = false
                        for (indexIn in it[index].packageItems) {
                            if (indexIn.isClick) {
                                isClicked = true
                            }
                        }
                        if (!isClicked) {
                            Toast.show(this, "请${it[index].packageName}")
                            isReturn = true
                            return@let
                        }

                    }
                }
            }
            if (isReturn) return
            //续期
            presenter?.getAllAmount()
        }

        //弹已选择对话框
        if (view == bottomLayout) {
            dialogData.let {
                if (it.listData.isEmpty()) {
                    return@let
                }
                var bundle = Bundle()
                bundle.putDouble("totalMoney", allPrice)
                bundle.putParcelableArrayList("infoList", it.listData)
                val orderConfirmInfoDialog = OrderConfirmInfoDialog()
                orderConfirmInfoDialog.arguments = bundle
                orderConfirmInfoDialog.show(supportFragmentManager, "OrderConfirmInfoDialog")
                orderConfirmInfoDialog.onBuyClickListener = object : OrderConfirmInfoDialog.OnBuyClickListener {
                    override fun onBuyClick() {
                        buyBikeBottomViewOkTv.performClick()
                    }
                }
            }

        }
    }

    override fun onResume() {
        super.onResume()
        presenter?.checkOrderPayStatus()
    }

    override fun setPresenter(presenter: RenewalFeeContract.Presenter?) {
    }

    override fun setAllData(dataBean: BuyBikeConfigResponse.DataBean) {
        this.dataBean = dataBean
        //车  电池信息
        dataBean.packageInfo?.let {
            titleData.clear()
            titleData.addAll(it)
            titleAdapter?.notifyDataSetChanged()
        }

        //续费图片信息
        dataBean.imgUrl?.let {
            ImageLoader.loadUrl(renewalImageView,it)
        }

        //电池押金
        if (state == 1 && dataBean.cashFlag == 1) {
            batteryDepositeConstraintLayout.visibility = View.VISIBLE
            batteryDepositeTitleTv.text = dataBean.cashAmountText
            batteryDepositeTv.text = dataBean.cashAmountRemark
        }

        //套餐处理
        packageData?.clear()
        if (dataBean.packages != null) {
            packageData?.addAll(dataBean.packages)
        }
        packageData?.let {
            for (index in it.indices) {
                if (it[index].packageItems == null && it[index].packageItems.isEmpty()){
                    return@let
                }
                var deadTimeAdapter = BuyBikePlantAdapter(it[index].required, this, it[index].packageItems, R.layout.item_buy_bike_plant)
                var view = layoutInflater.inflate(R.layout.item_buy_bike_plant_new, null)
                val recyclerView = view.findViewById<RecyclerView>(R.id.buyBikePlantRushTimeRecyclerView)
                val titleView = view.findViewById<TextView>(R.id.buyBikePlantRushTimeTv)
                val buyBikePlantTypeTv = view.findViewById<TextView>(R.id.buyBikePlantTypeTv)
                //详情icon
                val buyBikePlantRushTimeDetailIv = view.findViewById<ImageView>(R.id.buyBikePlantRushTimeDetailIv)
                //详情
                val buyBikePlantRushTimeDetailTv = view.findViewById<TextView>(R.id.buyBikePlantRushTimeDetailTv)
                //车辆租期,必选   描述文字
                val buyBikePlantRushTimeDescTv = view.findViewById<TextView>(R.id.buyBikePlantRushTimeDescTv)

                titleView.text = it[index].packageName
                recyclerView.layoutManager = GridLayoutManager(this, 2)
                recyclerView.adapter = deadTimeAdapter
                if (it[index].required == 1) {
                    it[index].packageItems[0].isClick = true
                }
                buyBikePlantRushTimeDescTv.text = it[index].packageDescription
                if (it[index].required == 1){
                    buyBikePlantTypeTv.visibility = View.GONE
                }else{
                    if (index == 0){
                        buyBikePlantTypeTv.visibility = View.VISIBLE
                    }else{
                        if (it[index].required == it[index-1].required){
                            buyBikePlantTypeTv.visibility = View.GONE
                        }else{
                            buyBikePlantTypeTv.visibility = View.VISIBLE
                        }
                    }
                }

                deadTimeAdapter.setOnItemClickListner { _, position ->
                    run {
                        var isClick = it[index].packageItems[position].isClick
                        if (it[index].required == 1 && isClick) {
                            return@run
                        }
                        for (index2 in it[index].packageItems.indices) {
                            it[index].packageItems[index2].isClick = false
                        }
                        it[index].packageItems[position].isClick = !isClick
                        initDialogList()
                        deadTimeAdapter.notifyDataSetChanged()
                    }
                }
                // 续费详情跳转
                buyBikePlantRushTimeDetailTv.setOnClickListener(fun(_: View?) {
                    JumpActivity.JumpWebView(this, it[index].packageName, it[index].packageUrl)
                })
                buyBikePlantRushTimeDetailIv.setOnClickListener(fun(_: View?) {
                    JumpActivity.JumpWebView(this, it[index].packageName, it[index].packageUrl)
                })
                renewalLinearLayout.addView(view)
            }
        }
        initDialogList()

    }

    @Synchronized
    private fun initDialogList() {
        allPrice = 0.00
        var itemList = arrayListOf<OrderConfirmItemBean>()
        itemList.clear()
        dataBean?.let {
            if (state == 1 && it.cashFlag == 1) {
                allPrice += it.cashAmount
                itemList.add(OrderConfirmItemBean(it.cashAmountRemark, "", it.cashAmountText, ""))
            }
        }
        packageData?.let {

            for (moneyIndex in it.indices) {
                if (it[moneyIndex].packageItems == null && it[moneyIndex].packageItems.isEmpty()){
                    return@let
                }
                for (moneyIndex2 in it[moneyIndex].packageItems.indices) {
                    if (it[moneyIndex].packageItems[moneyIndex2].isClick) {
                        var itemData = it[moneyIndex].packageItems[moneyIndex2]
                        allPrice += itemData.currentPrice
                        allPrice = fnum.format(allPrice).toDouble()
                        itemList.add(OrderConfirmItemBean(it[moneyIndex].packageName, "",
                                it[moneyIndex].packageItems[moneyIndex2].currentPriceText,
                                "${it[moneyIndex].packageItems[moneyIndex2].description}"))

                    }
                }
            }
            allPrice = fnum.format(allPrice).toDouble()
            buyBikeBottomViewMoneyTv.text = "￥$allPrice"
            buyBikeBottomViewMoneyChangeTv.setFloat(oldPrice.toFloat(), allPrice.toFloat())
            buyBikeBottomViewMoneyChangeTv.setDuration(600)
            buyBikeBottomViewMoneyChangeTv.start()
            dialogData.totalMoney = allPrice
            dialogData.listData = itemList
            oldPrice = allPrice
        }
    }


    override fun paySuccess() {
        //查单成功
        CommonTipsDialog.showDialog(this, supportFragmentManager, "支付成功", "", "好的", "", R.drawable.icon_tips_succeed, object : IDialogCallback() {
            override fun onConfirm() {
                super.onConfirm()
                this@RenewalFeeAct.finish()
            }
        })
    }

    override fun channelMethod(): Int = payMethod

    override fun wechatPay(dataBean: PayByOtherResponse.DataBean) {
        WechatPayUtils.wechatPay(this, dataBean.appid, dataBean.partnerid, dataBean.prepayid,
                dataBean.wxpackage, dataBean.noncestr, dataBean.timestamp,
                dataBean.sign)
    }

    override fun aliPay(dataBean: PayByOtherResponse.DataBean) {
        AliPayManager(this)
                .alipayV2(this, dataBean.orderInfo)
    }

    override fun onSuccess() {
    }

    override fun onFailed(msg: String?) {
        Toast.show(this, msg)
    }

    override fun bikeId(): Int = bikeId

    override fun pmallOrderId(): Int = pmallOrderId
    override fun virGroupId(): Int = virGroupId
    override fun packageType(): Int = state

    override fun packageItemIds(): String {
        var ids = ""
        packageData?.let {
            for (index in it.indices) {
                for (indexIn in it[index].packageItems.indices) {
                    if (it[index].packageItems[indexIn].isClick) {
                        ids = ids + it[index].packageItems[indexIn].packageItemId + ","
                    }
                }
            }

        }
        return ids
    }

    override fun showPayDialog(amount: Double) {
        payDialog = BuyInfiniteCardDialog.showDialog(supportFragmentManager, 1, "" + amount) { _, payMethod ->
            // 支付
            payDialog?.dismiss()
            this.payMethod = payMethod
            presenter?.payRequest()
        }
    }


}