package com.baojia.mebike.feature.exclusive.shopping.renewalfee

import android.app.Activity
import com.baojia.mebike.callback.HttpCallback
import com.baojia.mebike.data.response.exclusive.shapping.BuyBikeConfigResponse
import com.baojia.mebike.data.response.exclusive.shapping.BuyConfigCommitResponse
import com.baojia.mebike.feature.model.PayModel
import com.baojia.mebike.http.HttpUtils
import io.reactivex.disposables.Disposable

class RenewalFeeModel(activity: Activity) :PayModel(activity) {

    private val URL_ALLAMOUNT = "/pmall/create/renewal/order/v2"

    private val URL_RENEWAL_FEE = "/pmall/get/renewal/packages/v2"
    private val URL_RENEWAL_FEE_SERVICE = "/pmall/get/recharge/packages"
    fun getData(bikeId :Int,pmallOrderId :Int,httpCallback: HttpCallback<BuyBikeConfigResponse?>?) : Disposable {
        val params = HashMap<String, Any>()
        params["bikeId"] = bikeId
        params["pmallOrderId"] = pmallOrderId
        return HttpUtils.postRequest(activity, URL_RENEWAL_FEE, params, true, httpCallback, BuyBikeConfigResponse::class.java)
    }
    fun getDataTwo(bikeId :Int,pmallOrderId :Int,packageType :Int,httpCallback: HttpCallback<BuyBikeConfigResponse?>?) : Disposable {
        val params = HashMap<String, Any>()
        params["bikeId"] = bikeId
        params["pmallOrderId"] = pmallOrderId
        params["packageType"] = packageType
        return HttpUtils.postRequest(activity, URL_RENEWAL_FEE_SERVICE, params, true, httpCallback, BuyBikeConfigResponse::class.java)
    }

    fun getAllAmount(bikeId :Int,pmallOrderId :Int,packageItemIds :String,virGroupId :Int,httpCallback: HttpCallback<BuyConfigCommitResponse?>?) : Disposable {
        val params = HashMap<String, Any>()
            params["bikeId"] = bikeId
            params["pmallOrderId"] = pmallOrderId
            params["packageItemIds"] = packageItemIds
            params["virGroupId"] = virGroupId
        return HttpUtils.postRequest(activity, URL_ALLAMOUNT, params, true, httpCallback, BuyConfigCommitResponse::class.java)
    }

}