package com.baojia.mebike.feature.exclusive.shopping.aboutexclusive

import android.app.Activity
import android.text.TextUtils
import com.amap.api.mapcore.util.it
import com.baojia.mebike.base.BasePresenter
import com.baojia.mebike.callback.HttpCallback
import com.baojia.mebike.config.Config
import com.baojia.mebike.data.response.BaseResponse
import com.baojia.mebike.data.response.exclusive.shapping.BuyBikeConfigResponse
import com.baojia.mebike.data.response.exclusive.shapping.BuyConfigCommitResponse
import com.baojia.mebike.data.response.order.PayByOtherResponse
import com.baojia.mebike.feature.exclusive.shopping.renewalfee.RenewalFeeModel
import com.baojia.mebike.util.Toast

class RenewalFeePresenter(activity: Activity, val mView: RenewalFeeContract.View) : BasePresenter(activity), RenewalFeeContract.Presenter {



    val model = RenewalFeeModel(activity)
    var orderNo : String? = null

    override fun getData() {
        addDisposable(model.getData(mView.bikeId(),mView.pmallOrderId(), object : HttpCallback<BuyBikeConfigResponse?>() {
            override fun onSucceed(data: BuyBikeConfigResponse?) {
                super.onSucceed(data)
                data?.data?.let {
                    mView.setAllData(it)
                }
            }

            override fun onFailed(code: Int, message: String?) {
                super.onFailed(code, message)
                Toast.show(context, message)
            }

            override fun onError(code: Int, message: String?) {
                super.onError(code, message)
                onFailed(-1, message)
            }
        }))
    }

    //换电或者套餐的续期
    override fun getDataTwo() {
        addDisposable(model.getDataTwo(mView.bikeId(),mView.pmallOrderId(),mView.packageType(), object : HttpCallback<BuyBikeConfigResponse?>() {
            override fun onSucceed(data: BuyBikeConfigResponse?) {
                super.onSucceed(data)
                data?.data?.let {
                    mView.setAllData(it)
                }
            }

            override fun onFailed(code: Int, message: String?) {
                super.onFailed(code, message)
                Toast.show(context, message)
            }

            override fun onError(code: Int, message: String?) {
                super.onError(code, message)
                onFailed(-1, message)
            }
        }))
    }


    override fun payRequest() {
        this.addDisposable(model.prePay(mView.channelMethod(), 20,orderNo,
                object : HttpCallback<PayByOtherResponse.DataBean>() {
                    override fun onSucceed(data: PayByOtherResponse.DataBean) {
                        super.onSucceed(data)

                        orderNo = data.orderNo

                        if (data.payChannelId == Config.CODE_PAYCHANNLID_WECHAT) {
                            // 微信支付
                            mView.wechatPay(data)
                        } else if (data.payChannelId == Config.CODE_PAYCHANNLID_ALIPAY) {
                            // 支付宝支付
                            mView.aliPay(data)
                        }
                    }

                    override fun onFailed(code: Int, message: String) {
                        super.onFailed(code, message)
                    }
                }))
    }

    override fun checkOrderPayStatus() {
        if (TextUtils.isEmpty(orderNo)) {
            return
        }
        this.addDisposable(model.checkOrderPayStatus(orderNo, 20, object : HttpCallback<BaseResponse>() {
            override fun onSucceed(data: BaseResponse) {
                super.onSucceed(data)
                orderNo = null
                mView.paySuccess()
            }

            override fun onFailed(code: Int, message: String) {
                super.onFailed(code, message)
            }
        }))
    }

    override fun getAllAmount() {
        this.addDisposable(model.getAllAmount(mView.bikeId(),mView.pmallOrderId(),mView.packageItemIds(),mView.virGroupId(), object : HttpCallback<BuyConfigCommitResponse?>() {
            override fun onSucceed(data: BuyConfigCommitResponse?) {
                super.onSucceed(data)
                data?.data?.let {
                    mView.showPayDialog(it.orderAmount)
                    orderNo = it.orderNo
                }
            }
        }))
    }

}