package com.baojia.mebike.feature.exclusive.shopping.repairdetail

import android.app.Activity
import android.content.Intent
import android.os.Bundle
import android.text.TextUtils
import android.view.View
import androidx.recyclerview.widget.GridLayoutManager
import androidx.recyclerview.widget.LinearLayoutManager
import com.baojia.mebike.R
import com.baojia.mebike.base.BaseActivity
import com.baojia.mebike.data.response.exclusive.shapping.ShoppingRepailDetailResponse
import kotlinx.android.synthetic.main.activity_repair_ditail_shopping.*

class ShoppingRepairDetailActivity : BaseActivity(), ShoppingRepairDetailContarct.View {

    companion object {
        @JvmStatic
        fun start(activity: Activity,pmallMaintainId :Int? = 0){
            var intent = Intent(activity,ShoppingRepairDetailActivity::class.java)
            intent.putExtra("pmallMaintainId",pmallMaintainId)
            activity.startActivity(intent)
        }
    }

    var presenter: ShoppingRepairDetailPresenter? = null
    var pmallMaintainId: Int = 0
    val imagesList = arrayListOf<String>()
    val resultList = arrayListOf<ShoppingRepailDetailResponse.DataBean.ResultBean>()
    var imageAdapter :ImageShowAdapter? = null
    var resultAdapter :ResultProgressAdapter? = null

    override fun layoutId(): Int = R.layout.activity_repair_ditail_shopping

    override fun isVisibleTitleBar(): Boolean = true

    override fun setTitle(): String = "订单详情"

    override fun bindView(savedInstanceState: Bundle?) {
        intent?.let {
            pmallMaintainId = it.getIntExtra("pmallMaintainId", 0)
        }

        presenter = ShoppingRepairDetailPresenter(this, this)

        imageAdapter = ImageShowAdapter(this,imagesList,R.layout.item_pic_only)
        resultAdapter = ResultProgressAdapter(this,resultList,R.layout.item_progress_repair_detail)
        repairImagesRv.layoutManager = GridLayoutManager(this,4)
        repairImagesRv.adapter = imageAdapter
        orderDetailResultRv.layoutManager = LinearLayoutManager(this)
        orderDetailResultRv.adapter = resultAdapter

        presenter?.getDetail()
    }

    override fun setDetailData(data: ShoppingRepailDetailResponse.DataBean) {
        repairLocationContentTv.text = data.damagedPart
        repairTimeContentTv.text = data.createTime
        repairDescContentTv.text = data.description
        if (TextUtils.isEmpty(data.damagedPart)){
            repairLocationTv.visibility = View.GONE
            repairLocationContentTv.visibility = View.GONE
        }
        if (TextUtils.isEmpty(data.createTime)){
            repairTimeTv.visibility = View.GONE
            repairTimeContentTv.visibility = View.GONE
        }
        if (TextUtils.isEmpty(data.description)){
            repairDescTv.visibility = View.GONE
            repairDescContentTv.visibility = View.GONE
        }

        data.imgages?.let {
            imagesList.clear()
            imagesList.addAll(it)
            imageAdapter?.notifyDataSetChanged()
        }
        data.result?.let {
            resultList.clear()
            resultList.addAll(it)
            resultAdapter?.notifyDataSetChanged()
        }


    }

    override fun pmallMaintainId(): Int = pmallMaintainId

    override fun setPresenter(presenter: ShoppingRepairDetailContarct.Presenter?) {
    }

}