package com.baojia.mebike.feature.exclusive.shopping.repairlist

import android.app.Activity
import android.content.Intent
import android.os.Bundle
import androidx.recyclerview.widget.LinearLayoutManager
import com.amap.api.mapcore.util.it
import com.baojia.mebike.R
import com.baojia.mebike.base.BaseCommonAdapter
import com.baojia.mebike.base.BaseRefreshActivity
import com.baojia.mebike.data.response.exclusive.shapping.RepairListResponse
import com.baojia.mebike.feature.exclusive.shopping.repairdetail.ShoppingRepairDetailActivity
import kotlinx.android.synthetic.main.layout_recyclerview_only.*

class RepairListActivity :BaseRefreshActivity<RepairListContract.Presenter,RepairListContract.View>() ,RepairListContract.View {

    companion object {
        @JvmStatic
        fun start(activity: Activity,bikeId :Int){
            var intent = Intent(activity,RepairListActivity::class.java)
            intent.putExtra("bikeId",bikeId)
            activity.startActivity(intent)
        }
    }


    var bikeId = 0
    var mPresenter :RepairListPresenter? = null
    var mAdapter :RepairListAdapter? = null
    val mData = arrayListOf<RepairListResponse.DataBean>()

    override fun setCenterTitle(): String  = "维修保养记录"

    override fun isVisibleTitleBar(): Boolean = true

    override fun bindView(savedInstanceState: Bundle?) {
        intent?.let {
            bikeId = it.getIntExtra("bikeId",0)
        }
        super.bindView(savedInstanceState)
        mPresenter = RepairListPresenter(this,this)
    }

    override fun initAdapter() {
        mAdapter = RepairListAdapter(this,mData, R.layout.item_repair_list)
        recyclerview.layoutManager = LinearLayoutManager(this)
        recyclerview.adapter = mAdapter
        recyclerview.setBackgroundResource(R.color.background_color)

        mAdapter?.setOnItemClickListner { _, position ->
            run {
                ShoppingRepairDetailActivity.start(this@RepairListActivity, mData[position].pmallMaintainId )
            }
        }

        refreshLayout.autoRefresh()
    }

    override fun onRefresh() {
        mPresenter?.onRefresh()
    }

    override fun getAdapter(): BaseCommonAdapter<Any?> = mAdapter as BaseCommonAdapter<Any?>

    override fun onLoadMore() {
        mPresenter?.onLoadMore()
    }

    override fun bikeId(): Int = bikeId

    override fun setListData(data: List<RepairListResponse.DataBean>, isRefresh: Boolean) {
        if (isRefresh) {
            mData.clear()
        }
        mData.addAll(data)
        mAdapter?.notifyDataSetChanged()
    }
}