package com.baojia.mebike.feature.exclusive.shopping.repairlist

import android.app.Activity
import com.baojia.mebike.base.BasePresenter
import com.baojia.mebike.callback.HttpCallback
import com.baojia.mebike.data.response.exclusive.shapping.RepairListResponse

class RepairListPresenter(activity: Activity,val mView :RepairListContract.View) :BasePresenter(activity),RepairListContract.Presenter {

    override fun onLoadMore() {
        getList(currentPage,false)
    }

    override fun onRefresh() {
        getList(currentPage,true)
    }


    var currentPage = 1

    var mModel = RepairListModel(activity)

    fun getList(page: Int, isRefash: Boolean) {
        if (isRefash) {
            currentPage = 1
        } else {
            currentPage += 1
        }
        addDisposable(mModel.getListData(mView.bikeId(),currentPage, object : HttpCallback<RepairListResponse?>() {
            override fun onSucceed(data: RepairListResponse?) {
                super.onSucceed(data)
                if (isRefash) mView.refreshDataSucceed() else mView.loadMoreDataSucceed()
                data?.data?.let {
                    if (it.isEmpty()) {
                        mView.showNoDataPage()
                        return
                    }
                    mView.setListData(it,isRefash)

                }
            }

            override fun onFailed(code: Int, message: String?) {
                super.onFailed(code, message)
                if (isRefash) mView.refreshDataFailed(message) else mView.loadMoreDataFailed(message)
            }

            override fun onError(code: Int, message: String?) {
                super.onError(code, message)
                if (isRefash) mView.refreshDataFailed(message) else mView.loadMoreDataFailed(message)
                mView.showErrorPage()

            }
        }))
    }
}