package com.baojia.mebike.feature.exclusive.shopping.sendprogress

import android.content.Context
import android.content.Intent
import android.os.Bundle
import android.view.View
import androidx.recyclerview.widget.LinearLayoutManager
import com.baojia.mebike.R
import com.baojia.mebike.base.BaseActivity
import com.baojia.mebike.data.response.exclusive.shapping.SendProgressResponse
import io.reactivex.disposables.Disposable
import kotlinx.android.synthetic.main.include_bottom_common.*
import kotlinx.android.synthetic.main.layout_progress.*

class SendProgressActivity : BaseActivity(), SendProgressContract.View {

    companion object {
        @JvmStatic
        fun start(activity: Context, state: Int? = 0, orderNo: String?, changeBatteryId: Long? = 0, changeBatteryType: Int? = 1) {
            var intent = Intent(activity, SendProgressActivity::class.java)
            intent.putExtra("state", state)
            intent.putExtra("orderNo", orderNo)
            intent.putExtra("changeBatteryId", changeBatteryId)
            intent.putExtra("changeBatteryType", changeBatteryType)
            activity.startActivity(intent)

        }
    }

    override fun isVisibleTitleBar(): Boolean = true

    override fun layoutId(): Int = R.layout.layout_progress

    //0  配送   1  换电
    var state = 0
    var changeBatteryId: Long = 0

    var orderNo: String? = null

    var disposable: Disposable? = null

    val mDatas = arrayListOf<SendProgressResponse.DataBean.ProcessesBean>()
    var mAdapter: SendProgressAdapter? = null

    var changeBatteryType: Int = 1

    var presenter: SendProgressPresenter? = null

    override fun bindView(savedInstanceState: Bundle?) {

        intent?.let {
            state = it.getIntExtra("state", 0)
            orderNo = it.getStringExtra("orderNo")

            changeBatteryId = it.getLongExtra("changeBatteryId", 0)
            changeBatteryType = it.getIntExtra("changeBatteryType", 1)
        }

        if (state == 1) {
            setTitle(if (changeBatteryType == 1) "免费换电" else "紧急换电")
        }

        bottomViewOkLeftTv.visibility = View.GONE
        bottomViewOkRightTv.visibility = View.GONE
        bottomViewOkOnlyTv.visibility = View.VISIBLE
        bottomViewOkOnlyTv.text = "取消订单"
        setViewClickDuration(bottomViewOkOnlyTv, 1)

        presenter = SendProgressPresenter(this, this)

        progressRecyclerview.layoutManager = LinearLayoutManager(this)
        mAdapter = SendProgressAdapter(this, mDatas, R.layout.item_progress_send)
        progressRecyclerview.adapter = mAdapter

        presenter?.getData()

    }

    override fun setViewClick(view: View?) {
        super.setViewClick(view)
        if (view == bottomViewOkOnlyTv) {
            //取消订单
            presenter?.cancleOrder()
        }
    }

    override fun notifyData(data: ArrayList<SendProgressResponse.DataBean.ProcessesBean>) {
        mDatas.clear()
        mDatas.addAll(data)
        mAdapter?.notifyDataSetChanged()

    }

    override fun changeBatteryId(): Long = changeBatteryId

    override fun setPresenter(presenter: SendProgressContract.Presenter?) {
    }

    override fun orderNo(): String? = orderNo
    override fun state(): Int = state

    override fun showCancleOrder() {
        bottomLayout.visibility = View.VISIBLE
    }
}