package com.baojia.mebike.feature.exclusive.shopping.sendprogress

import android.app.Activity
import android.text.TextUtils
import com.baojia.mebike.base.BaseModel
import com.baojia.mebike.callback.HttpCallback
import com.baojia.mebike.data.response.BaseResponse
import com.baojia.mebike.data.response.exclusive.shapping.SendProgressResponse
import com.baojia.mebike.http.HttpUtils
import io.reactivex.disposables.Disposable

class SendProgressModel(activity: Activity) :BaseModel(activity) {

    private val LIST_PROGRESS = "/pmall/order/process/list/v3"
    private val LIST_PROGRESS_POWER = "/bike/knight/get/free/change"
    private val CANCLE_ORDER = "/bike/knight/cancel/battery/order"

    fun getData(state :Int,orderNo :String?,changeBatteryId:Long,httpCallback: HttpCallback<SendProgressResponse?>?) : Disposable {
        val params = HashMap<String, Any?>()
        if (!TextUtils.isEmpty(orderNo)) {
            params["orderNo"] = orderNo
        }
        if (changeBatteryId > 0) {
            params["id"] = changeBatteryId
        }
        return HttpUtils.postRequest(activity, if (state == 0) LIST_PROGRESS else LIST_PROGRESS_POWER , params, true, httpCallback, SendProgressResponse::class.java)
    }

    fun cancleOrder(orderNo :String?,changeBatteryId :Long?,httpCallback: HttpCallback<BaseResponse?>?) : Disposable {
        val params = HashMap<String, Any?>()
        params["changeBatteryId"] = changeBatteryId
        params["orderNo"] = orderNo

        return HttpUtils.postRequest(activity, CANCLE_ORDER, params, true, httpCallback, BaseResponse::class.java)
    }

}