package com.baojia.mebike.feature.exclusive.shopping.sendprogress

import android.app.Activity
import com.amap.api.mapcore.util.it
import com.baojia.mebike.base.BasePresenter
import com.baojia.mebike.callback.HttpCallback
import com.baojia.mebike.data.response.BaseResponse
import com.baojia.mebike.data.response.company_personal.CancleOrderResponse
import com.baojia.mebike.data.response.exclusive.shapping.SendProgressResponse
import com.baojia.mebike.util.Toast

class SendProgressPresenter(activity: Activity, val view: SendProgressContract.View) : BasePresenter(activity), SendProgressContract.Presenter {


    val model = SendProgressModel(activity)


    override fun getData() {
        addDisposable(model.getData(view.state(), view.orderNo(), view.changeBatteryId(), object : HttpCallback<SendProgressResponse?>() {
            override fun onSucceed(data: SendProgressResponse?) {
                super.onSucceed(data)
                data?.data?.processes?.let {
                    view.notifyData(it)
                }
                if (view.state() == 1) {
                    data?.data?.cancelOrderFlag.let {
                        if (it == 1) {
                            view.showCancleOrder()
                        }
                    }
                }
            }

            override fun onFailed(code: Int, message: String?) {
                super.onFailed(code, message)
            }

            override fun onError(code: Int, message: String?) {
                super.onError(code, message)
                onFailed(-1, message)
            }

            override fun onErrorByNoNetwork() {
                super.onErrorByNoNetwork()
                onFailed(-1, "")
            }
        }))
    }

    override fun cancleOrder() {
        addDisposable(model.cancleOrder(view.orderNo(), view.changeBatteryId(), object : HttpCallback<BaseResponse?>() {
            override fun onSucceed(data: BaseResponse?) {
                super.onSucceed(data)
                    Toast.show(context, data?.message)
                    context.finish()
            }

            override fun onFailed(code: Int, message: String?) {
                super.onFailed(code, message)
                Toast.show(context, message)
            }

            override fun onError(code: Int, message: String?) {
                super.onError(code, message)
                onFailed(-1, message)
            }

            override fun onErrorByNoNetwork() {
                super.onErrorByNoNetwork()
                onFailed(-1, "")
            }
        }))

    }


}