package com.baojia.mebike.feature.join.JoinBuyActivity

import com.baojia.mebike.base.IBasePresenter
import com.baojia.mebike.base.IBaseView
import com.baojia.mebike.data.response.order.PayByOtherResponse

class JoinBuyContract  {

    interface View : IBaseView<Presenter> {
    
        /**
         * 支付成功回调
         * @param dataBean
         */
         fun orderPaySucceed(dataBean: PayByOtherResponse.DataBean)

        /**
         * 支付方式
         * @return
         */
         fun payMethod(): Int

        //身份证hao
        fun contractIdCard():String

        //姓名
        fun getName():String
        //手机号
        fun getMobile():String
        //orderno
        fun orderNo() :String

        fun checkPaySuccess(url :String)

    }

    interface Presenter : IBasePresenter {
        /**
         * 支付
         */
         fun joinPay()

        /**
         * 查询订单支付状态
         */
         fun checkOrderPayStatus()

    }
}