package com.baojia.mebike.feature.join.JoinBuyActivity

import com.baojia.mebike.base.BasePresenter
import com.baojia.mebike.callback.HttpCallback
import com.baojia.mebike.data.response.DataStringResponse
import com.baojia.mebike.data.response.order.PayByOtherResponse
import com.baojia.mebike.util.Toast

class JoinBuyPresenter(val activity: JoinBuyActivity,val view :JoinBuyContract.View) : BasePresenter(activity),JoinBuyContract.Presenter{

    val model = JoinBuyModel(activity)
    private var orderNo: String? = null

    override fun joinPay() {
        addDisposable(model.orderPay(view.getName(), view.getMobile(), view.contractIdCard(),view.payMethod(),view.orderNo(), object : HttpCallback<PayByOtherResponse.DataBean>() {
            override fun onSucceed(data: PayByOtherResponse.DataBean) {
                super.onSucceed(data)
                view.orderPaySucceed(data)
                orderNo = data.orderNo
            }
        }))
    }

    override fun checkOrderPayStatus() {
        orderNo?.let { itt ->
            model.checkJoinPayStatus(itt,3, object : HttpCallback<DataStringResponse>() {
            override fun onSucceed(data: DataStringResponse?) {
                super.onSucceed(data)
                data?.let {
                    view.checkPaySuccess(it.data)
                }
            }

            override fun onFailed(code: Int, message: String?) {
                super.onFailed(code, message)
                Toast.show(context,"支付失败，未扣除费用，请重新尝试")
            }
        }) }

    }

}