package com.baojia.mebike.feature.join.contract

import android.content.Context
import androidx.fragment.app.FragmentManager
import androidx.recyclerview.widget.LinearLayoutManager
import androidx.recyclerview.widget.RecyclerView
import com.baojia.mebike.R
import com.baojia.mebike.base.BaseCommonAdapter
import com.baojia.mebike.base.BaseCommonAdapter.OnItemChildViewClickListner
import com.baojia.mebike.base.BaseViewHolder
import com.baojia.mebike.data.response.join.JoinContractResponse
import com.baojia.mebike.util.ToolBox
import com.baojia.mebike.util.recyclerview.RecycleViewDivider

/**
 * +----------------------------------------------------------------------
 * | @time 2019/4/17:9:25 AM
 * | @author house
 * | @class_describe
 * +----------------------------------------------------------------------
 **/
class ContractAdapter(val context: Context, mData: ArrayList<JoinContractResponse.DataBean>, val fragmentManager: FragmentManager) : BaseCommonAdapter<JoinContractResponse.DataBean>(context, mData, R.layout.item_contract) {

    override fun convert(holder: BaseViewHolder?, list: MutableList<JoinContractResponse.DataBean>?, position: Int) {

        if (list != null) {
            val data = list[position]

            holder?.setText(R.id.infoTextView, data.orderInfo)
            holder?.setText(R.id.dateTextView, data.orderTime)

            val itemAdapter = ContractItemAdapter(context, data.contractInfos)
            val recyclerView = holder?.findView(R.id.itemRecyclerView) as RecyclerView

            val manager = LinearLayoutManager(context)
            recyclerView.layoutManager = manager
            if (recyclerView.itemDecorationCount == 0){
                recyclerView.addItemDecoration(RecycleViewDivider(context, RecyclerView.VERTICAL, ToolBox.dip2px(1.0f), R.color.line_color, false))
            }
            recyclerView.adapter = itemAdapter

            itemAdapter.onItemChildViewClickListner = OnItemChildViewClickListner { view, itemPosition ->
                //                holder?.addOnClickListener(itemAdapter, view, position)
                when (view.id) {
                    R.id.sendMailButton -> {
                        onViewClickListener?.onClick(1, position, itemPosition)
                    }
                    R.id.loadContractButton -> {
                        onViewClickListener?.onClick(2, position, itemPosition)
                    }
                    R.id.itemView -> {
                        onViewClickListener?.onClick(0, position,itemPosition)
                    }
                }
            }

//            itemAdapter.onItemClickListner = OnItemClickListner { _, itemPosition ->
//                onViewClickListener?.onClick(0, position, itemPosition)
//            }
        }

    }

    var onViewClickListener: OnViewClickListener? = null

    interface OnViewClickListener {
        fun onClick(clickType: Int, position: Int, itemPosition: Int)
    }

}