package com.baojia.mebike.feature.join.contract

import android.content.Context
import androidx.core.content.ContextCompat
import com.baojia.mebike.R
import com.baojia.mebike.base.BaseCommonAdapter
import com.baojia.mebike.base.BaseViewHolder
import com.baojia.mebike.data.response.join.JoinContractResponse

/**
 * +----------------------------------------------------------------------
 * | @time 2019/4/17:9:25 AM
 * | @author house
 * | @class_describe
 * +----------------------------------------------------------------------
 **/
class ContractItemAdapter(val context: Context, mData: ArrayList<JoinContractResponse.DataBean.ContractInfosBean>) : BaseCommonAdapter<JoinContractResponse.DataBean.ContractInfosBean>(context, mData, R.layout.item_contract_item) {

    override fun convert(holder: BaseViewHolder?, list: MutableList<JoinContractResponse.DataBean.ContractInfosBean>?, position: Int) {

        if (list != null) {
            val data = list[position]

            holder?.setVisbility(R.id.sendMailButton, false)
            holder?.setVisbility(R.id.loadContractButton, false)

            holder?.setText(R.id.firstAgreement, data.contractName)
            var statusInfo = ""
            var statusColor = 0
            when (data.status) {
                0 -> {
                    // 未签约
                    statusInfo = "待签约"
                    statusColor = R.color.color_FF3939
                }
                1 -> {
                    // 履行中
                    statusInfo = "履行中"
                    statusColor = R.color.color_26C319
                    holder?.setVisbility(R.id.sendMailButton, true)
                    holder?.setVisbility(R.id.loadContractButton, true)
                }
                2 -> {
                    // 已终止
                    statusInfo = "已终止"
                    statusColor = R.color.text_third_color
                }
            }
            holder?.setTextColor(R.id.firstAgreementStatus, ContextCompat.getColor(context, statusColor))
            holder?.setText(R.id.firstAgreementStatus, statusInfo)

            holder?.addOnClickListener(this, R.id.sendMailButton, position)
            holder?.addOnClickListener(this, R.id.loadContractButton, position)
            holder?.addOnClickListener(this, holder?.itemView, position)
        }

    }
}