package com.baojia.mebike.feature.join.contract

import android.app.Activity
import com.baojia.mebike.base.BasePresenter
import com.baojia.mebike.callback.HttpCallback
import com.baojia.mebike.data.response.join.JoinContractResponse
import com.baojia.mebike.util.CollectionsWrapper

/**
 * +----------------------------------------------------------------------
 * | @time 2019/4/17:9:10 AM
 * | @author house
 * | @class_describe
 * +----------------------------------------------------------------------
 **/
class ContractPresenter(context: Activity, var mView: ContractContract.View) : BasePresenter(context), ContractContract.Presenter {


    private var contractModel: ContractModel? = null

    init {
        contractModel = ContractModel(getContext())
    }

    private var pageNum: Int = 1


    override fun onLoadMore() {
        getList(false)
    }

    override fun onRefresh() {
        getList(true)
    }

    private fun getList(isRefresh: Boolean) {

        if (isRefresh) {
            pageNum = 1
        } else {
            pageNum++
        }

        contractModel?.getContractList(pageNum, object : HttpCallback<JoinContractResponse>() {
            override fun onSucceed(data: JoinContractResponse?) {
                super.onSucceed(data)

                mView.hideAllPage()

                if (isRefresh) {
                    mView.refreshDataSucceed()
                } else {
                    mView.loadMoreDataSucceed()
                }

                data?.data?.let {
                    if (it.isEmpty()) {
                        mView.showNoDataPage()
                        return@let
                    }
                    mView.setData(it, isRefresh)
                }

            }

            override fun onFailed(code: Int, message: String?) {
                super.onFailed(code, message)
                if (isRefresh) mView.refreshDataFailed(message) else mView.loadMoreDataFailed(message)
            }

            override fun onError(code: Int, message: String?) {
                super.onError(code, message)
                if (isRefresh) mView.refreshDataFailed(message) else mView.loadMoreDataFailed(message)
                mView.showErrorPage()

            }
        })
    }

}