package com.baojia.mebike.feature.join.invitation.friend

import androidx.core.content.ContextCompat
import androidx.recyclerview.widget.LinearLayoutManager
import androidx.recyclerview.widget.RecyclerView
import com.baojia.mebike.R
import com.baojia.mebike.base.BaseCommonAdapter
import com.baojia.mebike.base.BaseRefreshFragment
import com.baojia.mebike.data.response.join.JoinInvitationFriendResponse
import com.baojia.mebike.util.CollectionsWrapper
import com.baojia.mebike.util.DensityUtil
import com.baojia.mebike.util.recyclerview.RecycleViewDivider
import kotlinx.android.synthetic.main.layout_recyclerview_only.*

/**
 * +----------------------------------------------------------------------
 * | @time 2019/3/28:11:12 AM
 * | @author house
 * | @class_describe 我的邀请Fragment
 * +----------------------------------------------------------------------
 **/
class InvitationFriendFragment() : BaseRefreshFragment<InvitationFriendContract.Presenter, InvitationFriendContract.View>(), InvitationFriendContract.View {

    // 1:直接邀请  2:间接邀请
    private var type: Int = 1
    private var mPresenter: InvitationFriendContract.Presenter? = null
    private var adapter: InvitationFriendAdapter? = null
    private val mData = ArrayList<JoinInvitationFriendResponse.DataBean>()

    companion object {

        fun newInstance(): InvitationFriendFragment = InvitationFriendFragment()

    }

    override fun bindView() {
        super.bindView()

        type = bundle.getInt("type")

        mPresenter = InvitationFriendPresenter(activity!!, this)

    }

    override fun initAdapter() {
        adapter = InvitationFriendAdapter(context!!, mData)
        recyclerview.setBackgroundColor(ContextCompat.getColor(context!!, R.color.background_color))
        refreshLayout.setBackgroundColor(ContextCompat.getColor(context!!, R.color.background_color))
        recyclerview.layoutManager = LinearLayoutManager(context)
        recyclerview.adapter = adapter
        recyclerview.addItemDecoration(RecycleViewDivider(context, RecyclerView.VERTICAL, DensityUtil.dip2px(context, 10f), R.color.background_color))
    }

    override fun onRefresh() {
        mPresenter?.onRefresh()
    }

    override fun getAdapter(): BaseCommonAdapter<Any?> = adapter as BaseCommonAdapter<Any?>

    override fun onLoadMore() {
        mPresenter?.onLoadMore()
    }

    override fun setPresenter(presenter: InvitationFriendContract.Presenter?) {

    }

    override fun getNoDataText(): CharSequence {
        return "尚未邀请好友"
    }

    override fun getType(): Int = type

    override fun setData(mData: ArrayList<JoinInvitationFriendResponse.DataBean>?, isRefresh: Boolean) {
        if (isRefresh) {
            this.mData.clear()
        }
        if (!CollectionsWrapper.isEmpty(mData) && mData != null) {
            this.mData.addAll(mData)
        }
        adapter?.notifyDataSetChanged()
    }
}