package com.baojia.mebike.feature.join.invitation.friend

import android.app.Activity
import com.baojia.mebike.base.BaseModel
import com.baojia.mebike.callback.HttpCallback
import com.baojia.mebike.data.response.join.JoinInvitationFriendResponse
import com.baojia.mebike.http.HttpUtils
import io.reactivex.disposables.Disposable

/**
 * +----------------------------------------------------------------------
 * | @time 2019/3/28:3:08 PM
 * | @author house
 * | @class_describe
 * +----------------------------------------------------------------------
 **/
class InvitationFriendModel(val context: Activity) : BaseModel(context) {

    private val INVITATION_FRIEND_URL = "/join/get/invitation/users"

    /**
     * @param score 邀请关系传1表示一级邀请关系，传2表示二级，默认1
     */
    fun getInvitationFriendData(pageNum:Int,score:Int,httpCallback: HttpCallback<JoinInvitationFriendResponse>) : Disposable{

        val params = mutableMapOf<String,Any?>()
        params["pageSize"] = 20
        params["pageNum"] = pageNum
        params["score"] = score

        return HttpUtils.postRequest(activity,INVITATION_FRIEND_URL,params,false,httpCallback,JoinInvitationFriendResponse::class.java )
    }
}