package com.baojia.mebike.feature.join.invitation.friend

import android.app.Activity
import com.baojia.mebike.base.BasePresenter
import com.baojia.mebike.callback.HttpCallback
import com.baojia.mebike.data.response.join.JoinInvitationFriendResponse
import com.baojia.mebike.util.CollectionsWrapper

/**
 * +----------------------------------------------------------------------
 * | @time 2019/3/28:11:17 AM
 * | @author house
 * | @class_describe
 * +----------------------------------------------------------------------
 **/
class InvitationFriendPresenter(val mContext: Activity, val mView: InvitationFriendContract.View) : BasePresenter(mContext),
        InvitationFriendContract.Presenter {

    var currentPage = 1
    private var invitationModel: InvitationFriendModel? = null

    init {
        invitationModel = InvitationFriendModel(mContext)
    }

    override fun onRefresh() {
        getListData(true)
    }

    override fun onLoadMore() {
        getListData(false)
    }


    private fun getListData(isRefresh: Boolean) {
        if (isRefresh) {
            currentPage = 1
        } else {
            currentPage += 1
        }
        invitationModel?.getInvitationFriendData(currentPage, mView.getType(), object : HttpCallback<JoinInvitationFriendResponse>() {
            override fun onSucceed(data: JoinInvitationFriendResponse?) {
                super.onSucceed(data)

                mView.hideAllPage()
                if (isRefresh) mView.refreshDataSucceed() else mView.loadMoreDataSucceed()
                data?.let {
                    mView.setData(it.data, isRefresh)
                    if (isRefresh) {
                        if (CollectionsWrapper.isEmpty(it.data)) {
                            mView.showNoDataPage()
                            return
                        }
                    }
                }
            }

            override fun onFailed(code: Int, message: String?) {
                super.onFailed(code, message)
                if (isRefresh) mView.refreshDataFailed(message) else mView.loadMoreDataFailed(message)
            }

            override fun onError(code: Int, message: String?) {
                super.onError(code, message)
                if (isRefresh) mView.refreshDataFailed(message) else mView.loadMoreDataFailed(message)
                mView.showErrorPage()

            }
        })
    }

}