package com.baojia.mebike.feature.join.invitation.income

import android.app.Activity
import com.baojia.mebike.base.BaseModel
import com.baojia.mebike.callback.HttpCallback
import com.baojia.mebike.data.response.join.JoinInvitationIncomeResponse
import com.baojia.mebike.http.HttpUtils
import io.reactivex.disposables.Disposable

/**
 * +----------------------------------------------------------------------
 * | @time 2019/3/28:3:08 PM
 * | @author house
 * | @class_describe
 * +----------------------------------------------------------------------
 **/
class InvitationIncomeModel(val context: Activity) : BaseModel(context) {

    private val INVITATION_INCOME_URL = "/join/get/invitation/rewards"

    /**
     * @param score 邀请关系传1表示一级邀请关系，传2表示二级，默认1
     */
    fun getInvitationIncomeData(pageNum:Int,score:Int,httpCallback: HttpCallback<JoinInvitationIncomeResponse>) : Disposable{

        val params = mutableMapOf<String,Any?>()
        params["pageSize"] = 20
        params["pageNum"] = pageNum
        params["score"] = score

        return HttpUtils.postRequest(activity,INVITATION_INCOME_URL,params,false,httpCallback,JoinInvitationIncomeResponse::class.java )
    }
}