package com.baojia.mebike.feature.join.invitation.income

import android.content.Context
import android.content.Intent
import android.os.Bundle
import android.view.View
import androidx.fragment.app.Fragment
import androidx.viewpager.widget.ViewPager
import com.baojia.mebike.R
import com.baojia.mebike.base.BaseActivity
import com.baojia.mebike.feature.adapter.FragmentPagerAdapter
import kotlinx.android.synthetic.main.activity_join_invivation.*

/**
 * +----------------------------------------------------------------------
 * | @time 2019/3/28:2:17 PM
 * | @author house
 * | @class_describe 加盟--我的邀请奖励
 * +----------------------------------------------------------------------
 **/
class JoinInvitationIncomeActivity : BaseActivity(), View.OnClickListener {

    companion object {

        @JvmStatic
        fun start(context:Context){
            context.startActivity(Intent(context,JoinInvitationIncomeActivity::class.java))
        }

    }

    private var directlyFragment = InvitationIncomeFragment.newInstance()
    private var indirectFragment = InvitationIncomeFragment.newInstance()
    private val mData = arrayListOf<Fragment>()

    override fun layoutId(): Int = R.layout.activity_join_invivation

    override fun bindView(savedInstanceState: Bundle?) {

        setTitle("邀请奖励")
        setTitleBackground(R.color.title_background_color)
        directButton.text = "直接邀请奖励"
        indirectButton.text = "间接邀请奖励"

        val bundle = Bundle()
        bundle.putInt("type", 1)
        directlyFragment?.arguments = bundle

        val bundle1 = Bundle()
        bundle1.putInt("type", 2)
        indirectFragment?.arguments = bundle1

        mData.add(directlyFragment)
        mData.add(indirectFragment)

        val adapter = FragmentPagerAdapter(supportFragmentManager, mData)
        viewPager.adapter = adapter
        viewPager.addOnPageChangeListener(object : ViewPager.OnPageChangeListener {
            override fun onPageScrollStateChanged(state: Int) {
            }

            override fun onPageScrolled(position: Int, positionOffset: Float, positionOffsetPixels: Int) {
            }

            override fun onPageSelected(position: Int) {
                when (position) {
                    0 -> {
                        directButton.setBackgroundResource(R.drawable.round_maincolor)
                        indirectButton.setBackgroundResource(R.drawable.transparent)
                    }
                    1 -> {
                        indirectButton.setBackgroundResource(R.drawable.round_maincolor)
                        directButton.setBackgroundResource(R.drawable.transparent)
                    }
                }
            }
        })
        directButton.setOnClickListener(this)
        indirectButton.setOnClickListener(this)
    }

    override fun onClick(v: View?) {
        when (v) {
            directButton -> {
                viewPager.currentItem = 0
            }
            indirectButton -> {
                viewPager.currentItem = 1
            }
        }
    }


    override fun isVisibleTitleBar(): Boolean {
        return true
    }
}