package com.baojia.mebike.feature.person_company.bike_location

import android.content.Context
import android.content.Intent
import android.os.Bundle
import android.view.View
import com.baojia.mebike.R
import com.baojia.mebike.base.BaseActivity
import com.baojia.mebike.dialog.SelectMapDialog
import kotlinx.android.synthetic.main.activity_bike_location.*

/**
 * +----------------------------------------------------------------------
 * | @time 2019/1/14:7:26 PM
 * | @author house
 * | @class_describe 车辆定位页面
 * +----------------------------------------------------------------------
 **/
class BikeLocationActivity : BaseActivity(),BikeLocationContract.View {


    companion object {
        fun start(mContext:Context,bikeId:Int) {
            val intent = Intent()
            intent.setClass(mContext,BikeLocationActivity::class.java)
            intent.putExtra("bikeId",bikeId)
            mContext.startActivity(intent)
        }
    }

    private var bikeId: Int = 0
    private var mapViewImp: BikeLocationMapViewImp? = null
    private var mPresenter : BikeLocationPresenter? = null
    private var latitude: Double = 0.0
    private var longitude:Double = 0.0

    override fun layoutId(): Int {
        return R.layout.activity_bike_location
    }

    override fun bindView(savedInstanceState: Bundle?) {

        mapView.onCreate(savedInstanceState)
        mapViewImp = BikeLocationMapViewImp(mapView)
        mapViewImp?.addLocationMarker()


        intent?.let {
            bikeId = it.getIntExtra("bikeId",0)
        }

        mPresenter = BikeLocationPresenter(this,this)
        mPresenter?.refreshBikeLocation()


        setViewClickDuration(refreshButton,1)
        setViewClickDuration(backButton,1)
        setViewClickDuration(navigationButton,1)
    }

    override fun setViewClick(view: View?) {
        super.setViewClick(view)
        when(view) {
            refreshButton -> {
                mPresenter?.refreshBikeLocation()
            }
            navigationButton -> {
                // 导航
                SelectMapDialog.show(this, supportFragmentManager, latitude, longitude)
            }
            backButton -> {
                finish()
            }
        }
    }

    override fun onResume() {
        super.onResume()
        mapViewImp?.onResume()
    }

    override fun onPause() {
        super.onPause()
        mapViewImp?.onPause()
    }

    override fun onDestroy() {
        super.onDestroy()
        mapViewImp?.onDestroy()
    }

    override fun bikeId(): Int  = bikeId

    override fun setBikeLocation(latitude: Double, longitude: Double, gpsTIme: String) {
        mapViewImp?.addBikeMarker(latitude,longitude,gpsTIme)
        this.latitude = latitude
        this.longitude = longitude
    }

    override fun setBikeAddress(address: String, street: String?) {
        addressTextView.text = address
    }

    override fun setPresenter(presenter: BikeLocationContract.Presenter?) {
        this.setIPresenter(mPresenter)
    }
}