package com.baojia.mebike.feature.person_company.bike_location

import android.view.LayoutInflater
import android.widget.TextView
import com.amap.api.maps.CameraUpdateFactory
import com.amap.api.maps.model.LatLng
import com.amap.api.maps.model.Marker
import com.baojia.mebike.R
import com.baojia.mebike.data.CommData
import com.baojia.mebike.map.GDMapView
import com.baojia.mebike.map.GDMapViewImp

/**
 * +----------------------------------------------------------------------
 * | @time 2019/1/14:7:28 PM
 * | @author house
 * | @class_describe
 * +----------------------------------------------------------------------
 **/
class BikeLocationMapViewImp(mapView: GDMapView) : GDMapViewImp(mapView) {

    private var bikeMarker: Marker? = null

    /**
     * 添加定位点
     */
    fun addLocationMarker() {
        CommData.locationConfig?.latLng?.let {
            mapView.addLocationMarker(CommData.locationConfig.latLng)
        }
    }

    /**
     * 添加车辆位置
     */
    fun addBikeMarker(latitude: Double, longitude: Double, updateTime: String?) {
        if (bikeMarker != null) {
            bikeMarker!!.destroy()
        }
        val view = LayoutInflater.from(mapView.context).inflate(R.layout.marker_bike_location, null)
        view?.let {
            val updateTimeTextView = view.findViewById<TextView>(R.id.updateTimeTextView)
            updateTimeTextView.text = updateTime ?: ""
            val latLng = LatLng(latitude, longitude)
            bikeMarker = mapView.addMarker(latLng, view, false)

            mapView.map.animateCamera(CameraUpdateFactory.newLatLng(latLng))
        }
    }
}