package com.baojia.mebike.feature.person_company.bike_location

import android.app.Activity
import com.baojia.mebike.base.BaseModel
import com.baojia.mebike.callback.HttpCallback
import com.baojia.mebike.data.response.company_personal.RefreshBikeLocationResponse
import com.baojia.mebike.http.HttpUtils
import com.baojia.mebike.util.Toast
import io.reactivex.disposables.Disposable

/**
 * +----------------------------------------------------------------------
 * | @time 2019/1/21:9:34 PM
 * | @author house
 * | @class_describe
 * +----------------------------------------------------------------------
 **/
class BikeLocationModel(mContext:Activity) : BaseModel(mContext){

    private val REFRESH_BIKE_LOCATION = "/pmall/refresh/location"

    fun refreshBikeLocation(bikeId:Int,httpCallback: HttpCallback<RefreshBikeLocationResponse.DataBean>):Disposable {
        val params = mutableMapOf<String,Any>()
        params["bikeId"] = bikeId
        return HttpUtils.postRequest(activity,REFRESH_BIKE_LOCATION,params,object:HttpCallback<RefreshBikeLocationResponse>(){
            override fun onSucceed(data: RefreshBikeLocationResponse?) {
                super.onSucceed(data)

                data?.data?.let {
                    httpCallback?.onSucceed(it)
                }
            }

            override fun onFailed(code: Int, message: String?) {
                super.onFailed(code, message)
                Toast.show(activity,message)
            }

            override fun onError(code: Int, message: String?) {
                super.onError(code, message)
                onFailed(code,message)
            }
        },RefreshBikeLocationResponse::class.java)
    }
}