package com.baojia.mebike.feature.person_company.bike_location

import android.app.Activity
import com.baojia.mebike.base.BasePresenter
import com.baojia.mebike.callback.HttpCallback
import com.baojia.mebike.data.response.company_personal.RefreshBikeLocationResponse

/**
 * +----------------------------------------------------------------------
 * | @time 2019/1/21:9:44 PM
 * | @author house
 * | @class_describe
 * +----------------------------------------------------------------------
 **/
class BikeLocationPresenter(mContext: Activity, var mView: BikeLocationContract.View) : BasePresenter(mContext), BikeLocationContract.Presenter {

    private var bikeLocationModel: BikeLocationModel? = null

    init {
        bikeLocationModel = BikeLocationModel(mContext)
    }

    override fun refreshBikeLocation() {
        bikeLocationModel?.refreshBikeLocation(mView.bikeId(), object : HttpCallback<RefreshBikeLocationResponse.DataBean>() {
            override fun onSucceed(data: RefreshBikeLocationResponse.DataBean) {
                super.onSucceed(data)
                mView.setBikeAddress(data?.address, data?.street)
                if (data.location != null && data.location.size == 2) {
                    mView.setBikeLocation(data.location[1], data.location[0], data.gpsTime)
                }
            }
        })
    }
}