package com.baojia.mebike.feature.person_company.bike_repair

import com.baojia.mebike.base.IBasePresenter
import com.baojia.mebike.base.IBaseView
import java.io.File

interface BikeRepairContract {

    interface View : IBaseView<Presenter> {

        /**
         * 车辆ID
         * @return
         */
        fun bikeId(): Int
        fun description(): String

        /**
         * 拍照的图片
         * @return
         */
         fun getPic(): List<File?>

        /**
         * 专属订单id
         */
        fun pmallOrderId() :Int

        /**
         * 损坏部位
         */
        fun damagedPart() :String

        /**
         * 显示购买布局文件
         */
        fun showBuyLayout()

        /**
         * 显示续期布局文件
         */
        fun showRenewalLayout(buttonValue:String,placeholder:String,title:String)
    }

    interface Presenter : IBasePresenter {

        /**
         * 报修数据提交
         */
        fun postRepair()

        /**
         * 图片上传
         */
        fun uploadPhoto()

        fun getAfterSale()
    }
}