package com.baojia.mebike.feature.person_company.bike_repair

import android.app.Activity
import com.baojia.mebike.base.BasePhotoModel
import com.baojia.mebike.callback.HttpCallback
import com.baojia.mebike.data.response.company_personal.AfterSaleResponse
import com.baojia.mebike.data.response.repair.mainrepair.ReportPostResponse
import com.baojia.mebike.http.HttpUtils
import com.baojia.mebike.util.ToolBox
import io.reactivex.disposables.Disposable
import java.util.*

class BikeRepairModel(activity: Activity) :BasePhotoModel(activity) {

    val URL_REPAIR = "/pmall/add/maintain"

    fun postRepair( bikeId: Int,pmallOrderId: Int, damagedPart: String,description: String, imagesURL: String,
                       httpCallback: HttpCallback<ReportPostResponse>): Disposable {
        val params = HashMap<String, Any>()
        params["bikeId"] = bikeId
        if (pmallOrderId != null && pmallOrderId > 0) {
            params["pmallOrderId"] = pmallOrderId
        }
        params["damagedPart"] = ToolBox.getString(damagedPart)
        params["description"] = ToolBox.getString(description)
        params["imagesURL"] = ToolBox.getString(imagesURL)
        return HttpUtils.postRequest(activity, URL_REPAIR, params, true, httpCallback, ReportPostResponse::class.java)

    }

    // 专属车 查询售后信息
    private val GET_AFTER_SALE = "/pmall/get/aftersale"

    /**
     * 专属车 查询售后信息
     *
     * @param bikeId
     * @param httpCallback
     * @return
     */
    fun getAfterSale(bikeId: Int, httpCallback: HttpCallback<AfterSaleResponse.DataBean>?): Disposable {
        val params = HashMap<String, Any>()
        params["bikeId"] = bikeId
        return HttpUtils.postRequest(activity, GET_AFTER_SALE, params, false, object : HttpCallback<AfterSaleResponse>() {

            override fun onSucceed(data: AfterSaleResponse) {
                super.onSucceed(data)
                if (data.data == null) {
                    return
                }
                httpCallback?.onSucceed(data.data)
            }
        }, AfterSaleResponse::class.java)
    }
}