package com.baojia.mebike.feature.person_company.usebike

import android.os.Bundle
import androidx.fragment.app.FragmentManager
import androidx.recyclerview.widget.LinearLayoutManager
import com.baojia.mebike.R
import com.baojia.mebike.base.BaseCompatDialogFragment
import com.baojia.mebike.callback.IDialogCallback
import com.baojia.mebike.data.CommData
import com.baojia.mebike.data.response.company_personal.PersonalBikeResponse
import kotlinx.android.synthetic.main.dialog_change_bike.*

/**
 * +----------------------------------------------------------------------
 * | @time 2019/1/14:5:47 PM
 * | @author house
 * | @class_describe 切换车辆dialog
 * +----------------------------------------------------------------------
 **/
class ChangeBikeDialog : BaseCompatDialogFragment() {

    companion object {
        fun show(fragmentManager: FragmentManager, mData: ArrayList<PersonalBikeResponse.DataBean>): ChangeBikeDialog {
            val bundle = Bundle()
            bundle.putParcelableArrayList("data", mData)
            val changeBikeDialog = ChangeBikeDialog()
            changeBikeDialog.arguments = bundle
            changeBikeDialog.show(fragmentManager, "dialog")
            return changeBikeDialog
        }
    }

    private var mData: ArrayList<PersonalBikeResponse.DataBean> = arrayListOf()
    private var changeBikeAdapter: ChangeBikeAdapter? = null

    override fun setContentView(): Int {
        return R.layout.dialog_change_bike
    }

    override fun bindView() {

        var data = arguments?.getParcelableArrayList<PersonalBikeResponse.DataBean>("data")
        if (null != data) {
            mData.addAll(data)
        }

        setDialogBottom()

        if (activity != null) {
            changeBikeAdapter = ChangeBikeAdapter(activity!!, mData, R.layout.item_use_bike_change)
        }
        bikeRecyclerView.layoutManager = LinearLayoutManager(activity)
        bikeRecyclerView.adapter = changeBikeAdapter

        changeBikeAdapter?.setOnItemClickListner { view, position ->
            dialogCallback?.onConfirm(position.toString())
            dismiss()
        }
    }

    override fun getStyle(): Int {
        return R.style.BottomAnimateDialog
    }

    override fun getWidth(): Int {
        return CommData.getScreen()[0]
    }

    private var dialogCallback: IDialogCallback? = null

    fun setDialogCallback(dialogCallback: IDialogCallback) {
        this.dialogCallback = dialogCallback
    }
}