package com.baojia.mebike.feature.person_company.usebike

import com.amap.api.maps.CameraUpdateFactory
import com.amap.api.maps.model.LatLng
import com.amap.api.maps.model.Marker
import com.baojia.mebike.R
import com.baojia.mebike.map.GDMapView
import com.baojia.mebike.map.GDMapViewImp

/**
 * +----------------------------------------------------------------------
 * | @time 2019/1/21:4:13 PM
 * | @author house
 * | @class_describe
 * +----------------------------------------------------------------------
 **/
class UseBikeImp( mapView:GDMapView) : GDMapViewImp(mapView) {

    private var bikeMarker: Marker? = null

    init {
        val uiSettings = mapView.map.uiSettings
        uiSettings.isRotateGesturesEnabled = false
        uiSettings.isScrollGesturesEnabled = false
        uiSettings.isTiltGesturesEnabled = false
        uiSettings.isZoomGesturesEnabled = false
    }

    fun addBikeMarker(latitude:Double,longitude:Double) {
        if (bikeMarker != null) {
            bikeMarker!!.destroy()
        }
        var latLng = LatLng(latitude,longitude)
        bikeMarker = mapView.addMarker(latLng, R.mipmap.bike_marker_icon,false)

        mapView.map.animateCamera(CameraUpdateFactory.newLatLng(latLng))
    }
}