package com.baojia.mebike.feature.person_company.usebike

import android.content.Context
import android.text.TextUtils
import android.view.View
import android.widget.TextView
import com.baojia.mebike.R
import com.baojia.mebike.base.BaseCommonAdapter
import com.baojia.mebike.base.BaseViewHolder
import com.baojia.mebike.data.response.company_personal.UseBikeResponse

/**
 * +----------------------------------------------------------------------
 * | @time 2019/1/21:4:22 PM
 * | @author house
 * | @class_describe
 * +----------------------------------------------------------------------
 **/
class UseBikeMenuItemAdapter(var mContext: Context, list: ArrayList<UseBikeResponse.DataBean.TagListBean>, layoutId: Int) : BaseCommonAdapter<UseBikeResponse.DataBean.TagListBean>(mContext, list, layoutId) {
    override fun convert(holder: BaseViewHolder?, list: MutableList<UseBikeResponse.DataBean.TagListBean>?, position: Int) {
        if (list != null) {

            list[position]?.let {
                when (it.tag) {
                    1 -> {
                        // 续期
                        holder?.setImageResource(R.id.iconImageView, R.mipmap.icon_use_bike_surplus_time)
                    }
                    2 -> {
                        // 换电
                        holder?.setImageResource(R.id.iconImageView, R.mipmap.icon_use_bike_exchange_battery)
                    }
                    3 -> {
                        // 维修保养
                        holder?.setImageResource(R.id.iconImageView, R.mipmap.icon_use_bike_maintenance)
                    }
                    4 -> {
                        // 归还车辆
                        holder?.setImageResource(R.id.iconImageView, R.mipmap.icon_use_bike_return_bike)
                    }
                    else -> {
                    }
                }

                var confirmButton = holder?.findView<TextView>(R.id.confirmButton)

                holder?.setText(R.id.titleTextView, it.title)
                if (!TextUtils.isEmpty(it.placeholder)) {
                    holder?.setText(R.id.introduceTextView, it.placeholder)
                    holder?.setVisbility(R.id.introduceTextView, true)
                } else {
                    holder?.setVisbility(R.id.introduceTextView, false)
                }

                if (!TextUtils.isEmpty(it.buttonText)) {
                    confirmButton?.text = it.buttonText
                    confirmButton?.visibility = View.VISIBLE
                    holder?.setVisbility(R.id.arrowImageView, false)
                } else {
                    confirmButton?.visibility = View.GONE
                    holder?.setVisbility(R.id.arrowImageView, true)
                }

                confirmButton?.setOnClickListener { view ->
                    when (it.buttonTag) {
                        1 -> {
                            // 车辆续期
                            onItemClickListner?.onItemClick(null,10)
                        }
                        2 -> {
                            // 电池续期
                            onItemClickListner?.onItemClick(null,11)
                        }
                        3 -> {
                            // 查看电池续期详情
                            onItemClickListner?.onItemClick(null,position)
                        }
                    }
                }
            }

            if (itemCount == position + 1) {
                holder?.setVisbility(R.id.lineImageView, false)
            } else {
                holder?.setVisbility(R.id.lineImageView, true)
            }

            holder?.itemView?.setOnClickListener{
                onItemClickListner?.onItemClick(it,position)
            }

        }


    }
}