package com.baojia.mebike.feature.person_company.usebike

import android.app.Activity
import com.baojia.mebike.base.aboutbike.AboutBikeModel
import com.baojia.mebike.callback.HttpCallback
import com.baojia.mebike.data.response.company_personal.PersonalBikeResponse
import com.baojia.mebike.data.response.company_personal.UseBikeResponse
import com.baojia.mebike.http.HttpUtils
import com.baojia.mebike.util.CollectionsWrapper
import com.baojia.mebike.util.Toast
import com.baojia.mebike.util.ToolBox
import io.reactivex.disposables.Disposable

/**
 * +----------------------------------------------------------------------
 * | @time 2019/1/14:5:32 PM
 * | @author house
 * | @class_describe
 * +----------------------------------------------------------------------
 **/
open class UseBikeModel(mContext: Activity) : AboutBikeModel(mContext) {
    // 我的专享车
    private val GET_BIKE_INFO_URL = "/pmall/get/bike/v2"
    // 企业专属车辆
    private val GET_COMPANY_BIKE_INFO_URL = "/bike/knight/get/companyBike"
    // 获取专享车列表
    private val GET_BIKE_LIST_URL = "/pmall/get/bikes/v2"

    fun getBikeInfo(bikeId: Int, httpCallback: HttpCallback<UseBikeResponse.DataBean>): Disposable {

        val params = mutableMapOf<String, Any>()


        var url = GET_BIKE_INFO_URL
        if (ToolBox.isCompanyExclusive()) {
            url = GET_COMPANY_BIKE_INFO_URL
        }
        if (bikeId > 0) {
            params["bikeId"] = bikeId
        }

        return HttpUtils.postRequest(activity, url, params, object : HttpCallback<UseBikeResponse>() {
            override fun onSucceed(data: UseBikeResponse?) {
                super.onSucceed(data)
                data?.data?.let {
                    httpCallback?.onSucceed(it)
                }
            }

            override fun onFailed(code: Int, message: String?) {
                super.onFailed(code, message)
                Toast.show(activity, message)
            }

            override fun onError(code: Int, message: String?) {
                super.onError(code, message)
                onFailed(code, message)
            }
        }, UseBikeResponse::class.java)
    }

    fun getBikeList(httpCallback: HttpCallback<ArrayList<PersonalBikeResponse.DataBean>>): Disposable {

        return HttpUtils.postRequest(activity, GET_BIKE_LIST_URL, null, object : HttpCallback<PersonalBikeResponse>() {
            override fun onSucceed(data: PersonalBikeResponse?) {
                super.onSucceed(data)
                if (!CollectionsWrapper.isEmpty(data?.data)) {
                    httpCallback?.onSucceed(data?.data)
                }
            }
        }, PersonalBikeResponse::class.java)
    }
}