package com.baojia.mebike.feature.scan.dialog

import android.os.Bundle
import android.view.View
import androidx.fragment.app.FragmentManager
import com.baojia.mebike.R
import com.baojia.mebike.base.BaseCompatDialogFragment
import com.baojia.mebike.callback.IDialogCallback
import com.baojia.mebike.data.CommData
import com.baojia.mebike.imageloader.ImageLoader
import kotlinx.android.synthetic.main.dialog_confirm_use_bike_company.*
import kotlinx.android.synthetic.main.include_bottom_common.*

/**
 * +----------------------------------------------------------------------
 * | @time 2019/1/21:7:47 PM
 * | @author house
 * | @class_describe 企业确认用车页面弹窗
 * +----------------------------------------------------------------------
 **/
class CompanyConfirmUseBikeDialog : BaseCompatDialogFragment() {

    companion object {
        fun show(fragmentManager: FragmentManager, bikeId: Int, driveDistance: Int, battery: Int, bikePlateNo: String,bikeImageUrl:String? = ""):CompanyConfirmUseBikeDialog {
            val bundle = Bundle()
            bundle.putString("bikePlateNo", bikePlateNo)
            bundle.putInt("bikeId", bikeId)
            bundle.putInt("driveDistance", driveDistance)
            bundle.putInt("battery", battery)
            bundle.putString("bikeImageUrl", bikeImageUrl)
            val dialog = CompanyConfirmUseBikeDialog()
            dialog.arguments = bundle
            dialog.show(fragmentManager,"dialog")
            return dialog
        }
    }

    private var bikeId: Int = 0
    private var driveDistance: Int = 0
    private var battery: Int = 0
    private var bikePlateNo: String? = null
    private var bikeImageUrl: String? = null

    override fun setContentView(): Int = R.layout.dialog_confirm_use_bike_company

    override fun bindView() {

        setDialogBottom()

        arguments?.let {
            bikeId = it.getInt("bikeId")
            driveDistance = it.getInt("driveDistance")
            battery = it.getInt("battery")
            bikePlateNo = it.getString("bikePlateNo")
            bikeImageUrl = it.getString("bikeImageUrl")
        }

        driveDistanceTextView.text = "${driveDistance}KM"
        batteryTextView.text = "${battery}%"
        bikeNoTextView.text = bikePlateNo
        ImageLoader.loadUrl(bikeImageView,bikeImageUrl)

        bottomViewOkLeftTv.text = "取消"
        bottomViewOkRightTv.text = "确认用车"

        setViewClickDuration(bottomViewOkLeftTv, 1)
        setViewClickDuration(bottomViewOkRightTv, 1)


    }

    override fun setViewClick(view: View?) {
        super.setViewClick(view)

        when (view) {
            bottomViewOkLeftTv -> {
                dismiss()
                dialogCallback?.onCancel()
            }
            bottomViewOkRightTv -> {
                dismiss()
                dialogCallback?.onConfirm()
            }
        }
    }

    override fun getWidth(): Int {
        return CommData.getScreen()[0]
    }

    override fun getStyle(): Int {
        return R.style.BottomAnimateDialog
    }

    private var dialogCallback: IDialogCallback? = null

    fun setIDialogCallback(dialogCallback: IDialogCallback) {
        this.dialogCallback = dialogCallback
    }

    override fun cancelable(): Boolean {
        return false
    }
}